/*
 * ItemBackup.java
 *
 * Created on 16. duben 2005, 12:43
 */

package net.sf.tomp.el.author;

/**
 * @author <a href="mailto:xkyselak@fi.muni.cz">Martin Kyselák</a>
 *
 *
 */
public class ItemBackup {
    private String id;
    
    private String title;
    
    private String body;
    
    /**
     * 
     * Creates a new instance of ItemBackup and sets its properties.
     * @param i ID to backup
     * @param t Title to backup
     * @param b Body to backup
     */
    public ItemBackup(String i, String t, String b) {
        id = i;
        title = t;
        body = b;
    }
    
    /**
     * Creates a new instance of ItemBackup and sets its properties.
     * @param t Title to backup
     * @param b Body to backup
     */
    public ItemBackup(String t, String b) {
        title = t;
        body = b;
    }
    
    /**
     * Returns the backed-up ID.
     * @return ID
     */
    public String getId() {
        return id;
    }
    
    /**
     * Returns the backed-up title.
     * @return title
     */
    public String getTitle() {
        return title;
    }
    
    /**
     * Returns the backed-up body.
     * @return body
     */
    public String getBody() {
        return body;
    }
    
    /**
     * Sets title and body for backup.
     * @param t Title to backup
     * @param b Body to backup
     */
    public void backUp2(String t, String b) {
        title = t;
        body = b;
    }
    
    /**
     * Sets id, title and body for backup.
     * @param i ID to backup
     * @param t Title to backup
     * @param b Body to backup
     */
    public void backUp3(String i, String t, String b) {
        id = i;
        title = t;
        body = b;
    }
    
}
