/*
 * Main.java
 *
 * Created on 20. únor 2005, 18:08
 */

package net.sf.tomp.el.author;

import java.io.IOException;

import net.sf.tomp.el.author.io.AuthorIO;

import org.dom4j.DocumentException;

/**
 * @author <a href="mailto:tomp@fi.muni.cz">RNDr. Tomáš Pitner, Ph.D.</a>
 * 
 * 
 */
public class Main {

	private static final String aspectNames[] = { "tasks", "lectures",
			"practices", "projects" };

	/*
	 * public void run() throws DocumentException, IOException { tree = new
	 * CourseTree(new File("c:/tomp/vyuka-test")); course = new Course(tree);
	 * 
	 * for (int n = 0; n < aspectNames.length; n++) { CourseAspect aspect = new
	 * CourseAspect(course, aspectNames[n]); System.out.println("===== " +
	 * aspectNames[n]);
	 * 
	 * File[] dirlist = aspect.listAspectDir(); for (int i = 0; i <
	 * dirlist.length; i++) { System.out.println(dirlist[i].getName()); } }
	 * 
	 * CourseAspect tasks = new CourseAspect(course, aspectNames[0]);
	 * 
	 * CourseAspectInstance task1 = new CourseAspectInstance(tasks);
	 * tasks.addInstance(task1); task1.addParameter(new Title("Title of the
	 * task1")); task1.addParameter(new InstanceNumber("01"));
	 * task1.addParameter(new SimpleBody("Body of the task1"));
	 * 
	 * CourseAspectInstance task2 = new CourseAspectInstance(tasks);
	 * tasks.addInstance(task2); task2.addParameter(new Title("Title of the
	 * task2")); task2.addParameter(new InstanceNumber("02"));
	 * task2.addParameter(new SimpleBody("Body of the task2"));
	 * 
	 * CourseAspectIO io = new CourseAspectIO(); Document docTasks =
	 * io.createTree(tasks); Document docTask1 = io.createTree(task1); //
	 * System.out.println(docTasks.getRootElement().getName());
	 * io.writeTree(docTasks, tasks); io.writeTree(docTask1, task1); }
	 */

	/**
	 * Creates new instance of AuthorIO, CourseTree, Course, Lecture.
	 * Sets lecture's description and saves it.
	 * Creates another instance CourseTree, loads it (the previously saved one)
	 * and prints it.
	 * Creates another instance of Lecture, loads it (the previously saved one)
	 * and prints it.
	 * @param args Command-line arguments
	 * @throws IOException
	 * @throws DocumentException
	 */
	public static void main(String[] args) throws DocumentException,
			IOException {
		AuthorIO io = new AuthorIO();
		CourseTree tree = io.loadCourseTree("/home/martin/tomp/vyuka-test");

		Course pb138 = tree.getCourse("pb138");
		Lecture last = pb138.getLectures().newLecture("last");
		last.getDescription().setTitle("Title of the last lecture");
		last.getDescription().setBody("Body of the last lecture");
		io.saveLecture(last);

		CourseTree tree2 = io.loadCourseTree("/home/martin/tomp/vyuka-test");
		Lecture last2 = tree2.getCourse("pb138").getLectures().getLecture(
				"last");
		System.out.println(tree2.getCurrentLecture());
		System.out.println(last2);

	}
}
