/*
 * AuthorGUI.java
 *
 * Created on 4. duben 2005, 21:37
 */

package net.sf.tomp.el.author.gui;

import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import org.dom4j.DocumentException;

import net.sf.tomp.el.author.Project;
import net.sf.tomp.el.author.Projects;
import net.sf.tomp.el.author.Practice;
import net.sf.tomp.el.author.Practices;
import net.sf.tomp.el.author.Tasks;
import net.sf.tomp.el.author.Task;
import net.sf.tomp.el.author.Course;
import net.sf.tomp.el.author.CourseTree;
import net.sf.tomp.el.author.Lectures;
import net.sf.tomp.el.author.Lecture;
import net.sf.tomp.el.author.io.AuthorIO;

import java.util.ArrayList;
import java.util.List;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import javax.swing.JTree;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.text.Position;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.MutableTreeNode;
import javax.swing.tree.TreePath;
import net.sf.tomp.el.author.ItemBackup;
import net.sf.tomp.el.is.BuildConfig;
import net.sf.tomp.el.is.Main;

/**
 *
 * @author  Martin Kyselák
 */
public class AuthorGUI extends javax.swing.JFrame {

    /** Creates new form AuthorGUI */
    public AuthorGUI() {
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jFrameNew = new javax.swing.JFrame();
        jLabelCourse = new javax.swing.JLabel();
        jComboBoxCourse = new javax.swing.JComboBox();
        jLabelNewId = new javax.swing.JLabel();
        jTextFieldNewId = new javax.swing.JTextField();
        jButtonCancel = new javax.swing.JButton();
        jButtonAddNew = new javax.swing.JButton();
        jFrameCopy = new javax.swing.JFrame();
        jLabelCourseCopy = new javax.swing.JLabel();
        jComboBoxCourseCopy = new javax.swing.JComboBox();
        jButtonCancelCopy = new javax.swing.JButton();
        jButtonAddCopy = new javax.swing.JButton();
        jPopup = new javax.swing.JPopupMenu();
        jPopupAdd = new javax.swing.JMenuItem();
        jPopupCopy = new javax.swing.JMenuItem();
        jPopupCopyNew = new javax.swing.JMenuItem();
        jPopupDelete = new javax.swing.JMenuItem();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        try {
            File dir = new File(root);
            if (!dir.exists()) {
                dir = selectDir();
                root = dir.getAbsolutePath();
                if (dir != null) {
                    String treeId = dir.getAbsolutePath();
                    this.repaint();
                }
            }
            io = new AuthorIO();
            tree = io.loadCourseTree(root);

            Course pb138 = tree.getCourse("pb138");
            course = pb138;

        } catch (MalformedURLException e) {
            e.printStackTrace();
            System.out.println("|||---URL");
        } catch (DocumentException e) {
            e.printStackTrace();
            System.out.println("|||---Document");
        } catch (IOException e) {
            e.printStackTrace();
            System.out.println("|||---IO");
        } catch (Exception e) {
            e.printStackTrace();
            System.out.println("|||---General");
        }
        jTree = new javax.swing.JTree();
        top = new DefaultMutableTreeNode(tree.getNameInTree());
        createNodes(top);
        jTree = new JTree(top);
        jPanel = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel1.setVisible(false);
        jTextField1 = new javax.swing.JTextField();
        jTextField1.setVisible(false);
        jLabel2 = new javax.swing.JLabel();
        jLabel2.setVisible(false);
        jTextField2 = new javax.swing.JTextField();
        jTextField2.setVisible(false);
        jLabel3 = new javax.swing.JLabel();
        jLabel3.setVisible(false);
        jTextField3 = new javax.swing.JTextField();
        jTextField3.setVisible(false);
        lblSelect = new javax.swing.JLabel();
        jButtonSave = new javax.swing.JButton();
        jButtonSave.setVisible(false);
        jButtonDiscard = new javax.swing.JButton();
        jButtonDiscard.setVisible(false);
        jButtonAdd = new javax.swing.JButton();
        jButtonAdd.setVisible(false);
        jButtonDelete = new javax.swing.JButton();
        jButtonDelete.setVisible(false);
        jButtonCopy = new javax.swing.JButton();
        jButtonCopy.setVisible(false);
        jButtonCopyToNew = new javax.swing.JButton();
        jButtonCopyToNew.setVisible(false);
        jMenuBar = new javax.swing.JMenuBar();
        jMenuFile = new javax.swing.JMenu();
        miSelectCourse = new javax.swing.JMenuItem();
        miSaveCourse = new javax.swing.JMenuItem();
        miBuild = new javax.swing.JMenuItem();
        miExit = new javax.swing.JMenuItem();
        jMenuNew = new javax.swing.JMenu();
        miNewCourse = new javax.swing.JMenuItem();
        miNewLecture = new javax.swing.JMenuItem();
        miNewTask = new javax.swing.JMenuItem();
        miNewPractice = new javax.swing.JMenuItem();
        miNewProject = new javax.swing.JMenuItem();
        jMenuLook = new javax.swing.JMenu();
        jRMenuLookCross = new javax.swing.JRadioButtonMenuItem();
        jRMenuLookDefault = new javax.swing.JRadioButtonMenuItem();
        jSeparator = new javax.swing.JSeparator();
        jRMenuLookWindows = new javax.swing.JRadioButtonMenuItem();
        jRMenuLookLinux = new javax.swing.JRadioButtonMenuItem();
        jRMenuLookGTK = new javax.swing.JRadioButtonMenuItem();
        jRMenuLookJava = new javax.swing.JRadioButtonMenuItem();
        jMenuHelp = new javax.swing.JMenu();
        Contents = new javax.swing.JMenuItem();

        jFrameNew.getContentPane().setLayout(
                new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 20, 5));

        jFrameNew.setName("jFrameNew");
        jFrameNew.setResizable(false);
        jLabelCourse.setText("Select course for new item:");
        jLabelCourse.setMaximumSize(null);
        jLabelCourse.setMinimumSize(null);
        jLabelCourse.setPreferredSize(new java.awt.Dimension(200, 20));
        jFrameNew.getContentPane().add(jLabelCourse);

        jComboBoxCourse.setEditable(true);
        jComboBoxCourse.setMaximumSize(null);
        jComboBoxCourse.setMinimumSize(null);
        jComboBoxCourse.setPreferredSize(new java.awt.Dimension(200, 20));
        jFrameNew.getContentPane().add(jComboBoxCourse);

        jLabelNewId.setText("New item ID:");
        jLabelNewId.setPreferredSize(new java.awt.Dimension(200, 20));
        jFrameNew.getContentPane().add(jLabelNewId);

        jTextFieldNewId.setMaximumSize(null);
        jTextFieldNewId.setMinimumSize(null);
        jTextFieldNewId.setPreferredSize(new java.awt.Dimension(200, 20));
        jFrameNew.getContentPane().add(jTextFieldNewId);

        jButtonCancel.setText("Cancel");
        jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCancelActionPerformed(evt);
            }
        });

        jFrameNew.getContentPane().add(jButtonCancel);

        jButtonAddNew.setText("Add");
        jButtonAddNew.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAddNewActionPerformed(evt);
            }
        });

        jFrameNew.getContentPane().add(jButtonAddNew);

        jFrameCopy.getContentPane().setLayout(
                new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 20, 5));

        jFrameCopy.setName("jFrameNew");
        jFrameCopy.setResizable(false);
        jLabelCourseCopy.setText("Select course for new item:");
        jLabelCourseCopy.setMaximumSize(null);
        jLabelCourseCopy.setMinimumSize(null);
        jLabelCourseCopy.setPreferredSize(new java.awt.Dimension(200, 20));
        jFrameCopy.getContentPane().add(jLabelCourseCopy);

        jComboBoxCourseCopy.setEditable(true);
        jComboBoxCourseCopy.setMaximumSize(null);
        jComboBoxCourseCopy.setMinimumSize(null);
        jComboBoxCourseCopy.setPreferredSize(new java.awt.Dimension(200, 20));
        jFrameCopy.getContentPane().add(jComboBoxCourseCopy);

        jButtonCancelCopy.setText("Cancel");
        jButtonCancelCopy
                .addActionListener(new java.awt.event.ActionListener() {
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        jButtonCancelCopyActionPerformed(evt);
                    }
                });

        jFrameCopy.getContentPane().add(jButtonCancelCopy);

        jButtonAddCopy.setText("Copy");
        jButtonAddCopy.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAddCopyActionPerformed(evt);
            }
        });

        jFrameCopy.getContentPane().add(jButtonAddCopy);

        jPopupAdd.setText("Add new item");
        jPopupAdd.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jPopupAddActionPerformed(evt);
            }
        });

        jPopup.add(jPopupAdd);

        jPopupCopy.setText("Copy to...");
        jPopupCopy.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jPopupCopyActionPerformed(evt);
            }
        });

        jPopup.add(jPopupCopy);

        jPopupCopyNew.setText("Copy to new course");
        jPopupCopyNew.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jPopupCopyNewActionPerformed(evt);
            }
        });

        jPopup.add(jPopupCopyNew);

        jPopupDelete.setText("Delete");
        jPopupDelete.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jPopupDeleteActionPerformed(evt);
            }
        });

        jPopup.add(jPopupDelete);

        getContentPane().setLayout(new java.awt.GridLayout(1, 2));

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("El_Author");
        setName("jFrame");
        setResizable(false);
        addWindowFocusListener(new java.awt.event.WindowFocusListener() {
            public void windowGainedFocus(java.awt.event.WindowEvent evt) {
                formWindowGainedFocus(evt);
            }

            public void windowLostFocus(java.awt.event.WindowEvent evt) {
            }
        });

        jPanel1.setLayout(new java.awt.BorderLayout());

        jPanel1.setPreferredSize(new java.awt.Dimension(250, 350));
        jScrollPane1.setMaximumSize(null);
        jScrollPane1.setMinimumSize(null);
        jScrollPane1.setPreferredSize(new java.awt.Dimension(250, 350));
        jTree.setBorder(new javax.swing.border.EtchedBorder());
        jTree.setMaximumSize(null);
        jTree.setMinimumSize(null);
        jTree.setPreferredSize(null);
        jTree.setVisibleRowCount(40);
        jTree
                .addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
                    public void valueChanged(
                            javax.swing.event.TreeSelectionEvent evt) {
                        jTreeValueChanged(evt);
                    }
                });
        jTree.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jTreeMousePressed(evt);
            }
        });

        jScrollPane1.setViewportView(jTree);

        jPanel1.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel1);

        jPanel.setMinimumSize(new java.awt.Dimension(250, 350));
        jPanel.setOpaque(false);
        jPanel.setPreferredSize(new java.awt.Dimension(250, 350));
        jLabel1.setText("jLabel1");
        jLabel1.setMaximumSize(null);
        jLabel1.setMinimumSize(null);
        jLabel1.setPreferredSize(new java.awt.Dimension(200, 20));
        jPanel.add(jLabel1);

        jTextField1.setText("jTextField1");
        jTextField1.setMaximumSize(null);
        jTextField1.setMinimumSize(null);
        jTextField1.setPreferredSize(new java.awt.Dimension(200, 20));
        jTextField1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField1ActionPerformed(evt);
            }
        });

        jPanel.add(jTextField1);

        jLabel2.setText("jLabel2");
        jLabel2.setMaximumSize(null);
        jLabel2.setMinimumSize(null);
        jLabel2.setPreferredSize(new java.awt.Dimension(200, 20));
        jPanel.add(jLabel2);

        jTextField2.setText("jTextField2");
        jTextField2.setMaximumSize(null);
        jTextField2.setMinimumSize(null);
        jTextField2.setPreferredSize(new java.awt.Dimension(200, 20));
        jTextField2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField2ActionPerformed(evt);
            }
        });

        jPanel.add(jTextField2);

        jLabel3.setText("jLabel3");
        jLabel3.setMaximumSize(null);
        jLabel3.setMinimumSize(null);
        jLabel3.setPreferredSize(new java.awt.Dimension(200, 20));
        jPanel.add(jLabel3);

        jTextField3.setText("jTextField3");
        jTextField3.setMaximumSize(null);
        jTextField3.setMinimumSize(null);
        jTextField3.setPreferredSize(new java.awt.Dimension(200, 20));
        jTextField3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField3ActionPerformed(evt);
            }
        });

        jPanel.add(jTextField3);

        lblSelect.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblSelect.setText("Select an item from the tree.");
        lblSelect.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        lblSelect.setMaximumSize(null);
        lblSelect.setMinimumSize(null);
        lblSelect.setPreferredSize(new java.awt.Dimension(200, 20));
        jPanel.add(lblSelect);

        jButtonSave.setText("Save");
        jButtonSave.setEnabled(false);
        jButtonSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSaveActionPerformed(evt);
            }
        });

        jPanel.add(jButtonSave);

        jButtonDiscard.setText("Discard changes");
        jButtonDiscard.setEnabled(false);
        jButtonDiscard.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonDiscardActionPerformed(evt);
            }
        });

        jPanel.add(jButtonDiscard);

        jButtonAdd.setText("Add item");
        jButtonAdd.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAddActionPerformed(evt);
            }
        });

        jPanel.add(jButtonAdd);

        jButtonDelete.setText("Delete this item");
        jButtonDelete.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonDeleteActionPerformed(evt);
            }
        });

        jPanel.add(jButtonDelete);

        jButtonCopy.setText("Copy this item to");
        jButtonCopy.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCopyActionPerformed(evt);
            }
        });

        jPanel.add(jButtonCopy);

        jButtonCopyToNew.setText("Copy this item to new course");
        jButtonCopyToNew.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCopyToNewActionPerformed(evt);
            }
        });

        jPanel.add(jButtonCopyToNew);

        getContentPane().add(jPanel);

        jMenuFile.setText("File");
        miSelectCourse.setText("Select Course");
        miSelectCourse.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miSelectCourseActionPerformed(evt);
            }
        });

        jMenuFile.add(miSelectCourse);

        miSaveCourse.setText("Save Course");
        jMenuFile.add(miSaveCourse);

        miExit.setText("Exit");
        miExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miExitActionPerformed(evt);
            }
        });

        jMenuFile.add(miExit);

        miBuild.setText("Build");
        miBuild.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                try {
                    BuildConfig bc = new BuildConfig(tree);
                    new Main(bc, false).setVisible(true);
                } catch (IOException ioe) {

                }
            }
        });

        jMenuFile.add(miBuild);

        jMenuBar.add(jMenuFile);

        jMenuNew.setText("New");
        miNewCourse.setText("Course...");
        miNewCourse.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miNewCourseActionPerformed(evt);
            }
        });

        jMenuNew.add(miNewCourse);

        miNewLecture.setText("Lecture...");
        miNewLecture.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miNewLectureActionPerformed(evt);
            }
        });

        jMenuNew.add(miNewLecture);

        miNewTask.setText("Task...");
        miNewTask.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miNewTaskActionPerformed(evt);
            }
        });

        jMenuNew.add(miNewTask);

        miNewPractice.setText("Practice...");
        miNewPractice.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miNewPracticeActionPerformed(evt);
            }
        });

        jMenuNew.add(miNewPractice);

        miNewProject.setText("Project...");
        miNewProject.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miNewProjectActionPerformed(evt);
            }
        });

        jMenuNew.add(miNewProject);

        jMenuBar.add(jMenuNew);

        jMenuLook.setText("Look & Feel");
        jMenuLook.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuLookActionPerformed(evt);
            }
        });

        jRMenuLookCross.setSelected(true);
        jRMenuLookCross.setText("Cross-platform");
        jRMenuLookCross.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRMenuLookCrossActionPerformed(evt);
            }
        });

        jMenuLook.add(jRMenuLookCross);

        jRMenuLookDefault.setText("System default");
        jRMenuLookDefault
                .addActionListener(new java.awt.event.ActionListener() {
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        jRMenuLookDefaultActionPerformed(evt);
                    }
                });

        jMenuLook.add(jRMenuLookDefault);

        jMenuLook.add(jSeparator);

        jRMenuLookWindows.setText("Windows");
        jRMenuLookWindows
                .addActionListener(new java.awt.event.ActionListener() {
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        jRMenuLookWindowsActionPerformed(evt);
                    }
                });

        jMenuLook.add(jRMenuLookWindows);

        jRMenuLookLinux.setText("Linux/Motif");
        jRMenuLookLinux.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRMenuLookLinuxActionPerformed(evt);
            }
        });

        jMenuLook.add(jRMenuLookLinux);

        jRMenuLookGTK.setText("Linux/GTK");
        jRMenuLookGTK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRMenuLookGTKActionPerformed(evt);
            }
        });

        jMenuLook.add(jRMenuLookGTK);

        jRMenuLookJava.setText("Java default (Metal)");
        jRMenuLookJava.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRMenuLookJavaActionPerformed(evt);
            }
        });

        jMenuLook.add(jRMenuLookJava);

        jMenuBar.add(jMenuLook);

        jMenuHelp.setText("Help");
        Contents.setText("Contents");
        jMenuHelp.add(Contents);

        jMenuBar.add(jMenuHelp);

        setJMenuBar(jMenuBar);

        pack();
    }//GEN-END:initComponents

    private void jPopupAddActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jPopupAddActionPerformed
        jButtonAddActionPerformed(null);
    }//GEN-LAST:event_jPopupAddActionPerformed

    private void jPopupCopyNewActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jPopupCopyNewActionPerformed
        jButtonCopyToNewActionPerformed(null);
    }//GEN-LAST:event_jPopupCopyNewActionPerformed

    private void jPopupCopyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jPopupCopyActionPerformed
        jButtonCopyActionPerformed(null);
    }//GEN-LAST:event_jPopupCopyActionPerformed

    private void jPopupDeleteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jPopupDeleteActionPerformed
        jButtonDeleteActionPerformed(null);
    }//GEN-LAST:event_jPopupDeleteActionPerformed

    private void jTreeMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTreeMousePressed
        if (evt.getModifiers() == 4) {
            TreePath selPath = jTree.getPathForLocation(evt.getX(), evt.getY());
            jTree.setSelectionPath(selPath);
            // setting up the popup menu for each tree item ...
            if (selPath != null) {
                switch (selected) {
                // course selected
                case 0:
                    jPopupDelete.setVisible(true);
                    jPopupDelete.setText("Delete this course");
                    jPopupCopy.setVisible(false);
                    jPopupCopyNew.setText("Clone this course");
                    jPopupAdd.setVisible(false);
                    break;
                // lecture selected
                case 1:
                    jPopupDelete.setVisible(true);
                    jPopupDelete.setText("Delete this lecture");
                    jPopupCopy.setVisible(true);
                    jPopupCopy.setText("Copy this lecture to...");
                    jPopupCopyNew.setVisible(true);
                    jPopupCopyNew.setText("Copy this lecture to new course");
                    jPopupAdd.setVisible(false);
                    break;
                // task selected
                case 2:
                    jPopupDelete.setVisible(true);
                    jPopupDelete.setText("Delete this task");
                    jPopupCopy.setVisible(true);
                    jPopupCopy.setText("Copy this task to...");
                    jPopupCopyNew.setVisible(true);
                    jPopupCopyNew.setText("Copy this task to new course");
                    jPopupAdd.setVisible(false);
                    break;
                // practice selected
                case 3:
                    jPopupDelete.setVisible(true);
                    jPopupDelete.setText("Delete this practice");
                    jPopupCopy.setVisible(true);
                    jPopupCopy.setText("Copy this practice to...");
                    jPopupCopyNew.setVisible(true);
                    jPopupCopyNew.setText("Copy this practice to new course");
                    jPopupAdd.setVisible(false);
                    break;
                // project selected
                case 4:
                    jPopupDelete.setVisible(true);
                    jPopupDelete.setText("Delete this project");
                    jPopupCopy.setVisible(true);
                    jPopupCopy.setText("Copy this project to...");
                    jPopupCopyNew.setVisible(true);
                    jPopupCopyNew.setText("Copy this project to new course");
                    jPopupAdd.setVisible(false);
                    break;
                // lectures selected
                case 11:
                    jPopupDelete.setVisible(false);
                    jPopupCopy.setVisible(true);
                    jPopupCopy.setText("Copy all lectures to...");
                    jPopupCopyNew.setVisible(true);
                    jPopupCopyNew.setText("Copy all lectures to new course");
                    jPopupAdd.setVisible(true);
                    jPopupAdd.setText("Add new lecture");
                    break;
                // tasks selected
                case 22:
                    jPopupDelete.setVisible(false);
                    jPopupCopy.setVisible(true);
                    jPopupCopy.setText("Copy all tasks to...");
                    jPopupCopyNew.setVisible(true);
                    jPopupCopyNew.setText("Copy all tasks to new course");
                    jPopupAdd.setVisible(true);
                    jPopupAdd.setText("Add new task");
                    break;
                // practices selected
                case 33:
                    jPopupDelete.setVisible(false);
                    jPopupCopy.setVisible(true);
                    jPopupCopy.setText("Copy all practices to...");
                    jPopupCopyNew.setVisible(true);
                    jPopupCopyNew.setText("Copy all practices to new course");
                    jPopupAdd.setVisible(true);
                    jPopupAdd.setText("Add new practice");
                    break;
                // projects selected
                case 44:
                    jPopupDelete.setVisible(false);
                    jPopupCopy.setVisible(true);
                    jPopupCopy.setText("Copy all projects to...");
                    jPopupCopyNew.setVisible(true);
                    jPopupCopyNew.setText("Copy all projects to new course");
                    jPopupAdd.setVisible(true);
                    jPopupAdd.setText("Add new project");
                    break;
                // error
                default:
                    System.out.println("Error selecting item...");
                    System.out.println("-> jTreeMousePressed");
                }
                jPopup.show(evt.getComponent(), evt.getX(), evt.getY());
            }
        }
    }//GEN-LAST:event_jTreeMousePressed

    private void jButtonCopyToNewActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCopyToNewActionPerformed
        Course old_course = course;
        String newId = JOptionPane.showInputDialog("New course id: ");
        // course with ID exists?
        while (tree.getCourse(newId) != null) {
            JOptionPane.showMessageDialog(this, "Course with ID " + newId
                    + " already exists. Please type new ID.");
            newId = JOptionPane.showInputDialog("New id for course: ");
        }
        if (newId != null) {
            switch (selected) {
            // course selected
            case 0: {
                try {
                    // creating new course
                    course = tree.newCourse(newId);
                    course.updateNameInTree();
                    io.saveCourse(course);
                    // copying lectures
                    for (Lecture lecture : old_course.getLectures()
                            .getLectures()) {
                        // copying lecture
                        Lecture lect = course.getLectures().newLecture(
                                lecture.getId());
                        lect.getDescription().setTitle(
                                lecture.getDescription().getTitle());
                        lect.getDescription().setBody(
                                lecture.getDescription().getBody());
                        lect.updateNameInTree();
                        io.saveLecture(lect);
                    }
                    io.saveLecturesInclude(course.getLectures());
                    // copying tasks
                    for (Task task : old_course.getTasks().getTasks()) {
                        // copying task
                        Task tas = course.getTasks().newTask(task.getId());
                        tas.getDescription().setTitle(
                                task.getDescription().getTitle());
                        tas.getDescription().setBody(
                                task.getDescription().getBody());
                        tas.updateNameInTree();
                        io.saveTask(tas);
                    }
                    io.saveTasksInclude(course.getTasks());
                    // copying practices
                    for (Practice practice : old_course.getPractices()
                            .getPractices()) {
                        // copying practice
                        Practice prac = course.getPractices().newPractice(
                                practice.getId());
                        prac.getDescription().setTitle(
                                practice.getDescription().getTitle());
                        prac.getDescription().setBody(
                                practice.getDescription().getBody());
                        prac.updateNameInTree();
                        io.savePractice(prac);
                    }
                    io.savePracticesInclude(course.getPractices());
                    // copying projects
                    for (Project project : old_course.getProjects()
                            .getProjects()) {
                        // copying project
                        Project proj = course.getProjects().newProject(
                                project.getId());
                        proj.getDescription().setTitle(
                                project.getDescription().getTitle());
                        proj.getDescription().setBody(
                                project.getDescription().getBody());
                        proj.updateNameInTree();
                        io.saveProject(proj);
                    }
                    io.saveProjectsInclude(course.getProjects());
                    // reloading tree...
                    top = new DefaultMutableTreeNode(tree.getNameInTree());
                    createNodes(top);
                    DefaultTreeModel model = (DefaultTreeModel) jTree
                            .getModel();
                    model.setRoot(top);
                    TreePath path = jTree.getNextMatch(course.getNameInTree(),
                            0, Position.Bias.Forward);
                    System.out.println(path);
                    jTree.setSelectionPath(path);
                } catch (IOException ex) {
                    JOptionPane.showMessageDialog(this,
                            "Can't create XML file for new lecture.");
                    ex.printStackTrace();
                } catch (NullPointerException ex) {
                    ex.printStackTrace();
                } catch (Exception ex) {
                    JOptionPane.showMessageDialog(this,
                            "Cannot save the lecture " + ex,
                            "Cannot save the lecture " + ex,
                            JOptionPane.ERROR_MESSAGE);
                    ex.printStackTrace();
                }
                break;
            }
            // lecture selected
            case 1:
                try {
                    // creating new course
                    course = tree.newCourse(newId);
                    course.updateNameInTree();
                    io.saveCourse(course);
                    // copying lecture
                    Lecture lect = course.getLectures().newLecture(
                            lecture.getId());
                    lect.getDescription().setTitle(
                            lecture.getDescription().getTitle());
                    lect.getDescription().setBody(
                            lecture.getDescription().getBody());
                    lect.updateNameInTree();
                    io.saveLecture(lect);
                    io.saveLecturesInclude(course.getLectures());
                    // reloading tree...
                    top = new DefaultMutableTreeNode(tree.getNameInTree());
                    createNodes(top);
                    DefaultTreeModel model = (DefaultTreeModel) jTree
                            .getModel();
                    model.setRoot(top);
                    TreePath path = jTree.getNextMatch(course.getNameInTree(),
                            0, Position.Bias.Forward);
                    System.out.println(path);
                    jTree.setSelectionPath(path);
                } catch (IOException ex) {
                    JOptionPane.showMessageDialog(this,
                            "Can't create XML file for new lecture.");
                    ex.printStackTrace();
                } catch (NullPointerException ex) {
                    ex.printStackTrace();
                } catch (Exception ex) {
                    JOptionPane.showMessageDialog(this,
                            "Cannot save the lecture " + ex,
                            "Cannot save the lecture " + ex,
                            JOptionPane.ERROR_MESSAGE);
                    ex.printStackTrace();
                }
                break;
            // task selected
            case 2:
                try {
                    // creating new course
                    course = tree.newCourse(newId);
                    course.updateNameInTree();
                    io.saveCourse(course);
                    // copying task
                    Task tas = course.getTasks().newTask(task.getId());
                    tas.getDescription().setTitle(
                            task.getDescription().getTitle());
                    tas.getDescription().setBody(
                            task.getDescription().getBody());
                    tas.updateNameInTree();
                    io.saveTask(tas);
                    io.saveTasksInclude(course.getTasks());
                    // reloading tree...
                    top = new DefaultMutableTreeNode(tree.getNameInTree());
                    createNodes(top);
                    DefaultTreeModel model = (DefaultTreeModel) jTree
                            .getModel();
                    model.setRoot(top);
                    TreePath path = jTree.getNextMatch(course.getNameInTree(),
                            0, Position.Bias.Forward);
                    System.out.println(path);
                    jTree.setSelectionPath(path);
                } catch (IOException ex) {
                    JOptionPane.showMessageDialog(this,
                            "Can't create XML file for new task.");
                    ex.printStackTrace();
                } catch (NullPointerException ex) {
                    ex.printStackTrace();
                } catch (Exception ex) {
                    JOptionPane.showMessageDialog(this, "Cannot save the task "
                            + ex, "Cannot save the task " + ex,
                            JOptionPane.ERROR_MESSAGE);
                    ex.printStackTrace();
                }
                break;
            // practice selected
            case 3:
                try {
                    // creating new course
                    course = tree.newCourse(newId);
                    course.updateNameInTree();
                    io.saveCourse(course);
                    // copying practice
                    Practice prac = course.getPractices().newPractice(
                            practice.getId());
                    prac.getDescription().setTitle(
                            practice.getDescription().getTitle());
                    prac.getDescription().setBody(
                            practice.getDescription().getBody());
                    prac.updateNameInTree();
                    io.savePractice(prac);
                    io.savePracticesInclude(course.getPractices());
                    // reloading tree...
                    top = new DefaultMutableTreeNode(tree.getNameInTree());
                    createNodes(top);
                    DefaultTreeModel model = (DefaultTreeModel) jTree
                            .getModel();
                    model.setRoot(top);
                    TreePath path = jTree.getNextMatch(course.getNameInTree(),
                            0, Position.Bias.Forward);
                    System.out.println(path);
                    jTree.setSelectionPath(path);
                } catch (IOException ex) {
                    JOptionPane.showMessageDialog(this,
                            "Can't create XML file for new practice.");
                    ex.printStackTrace();
                } catch (NullPointerException ex) {
                    ex.printStackTrace();
                } catch (Exception ex) {
                    JOptionPane.showMessageDialog(this,
                            "Cannot save the practice " + ex,
                            "Cannot save the practice " + ex,
                            JOptionPane.ERROR_MESSAGE);
                    ex.printStackTrace();
                }
                break;
            // project selected
            case 4:
                try {
                    // creating new course
                    course = tree.newCourse(newId);
                    course.updateNameInTree();
                    io.saveCourse(course);
                    // copying project
                    Project proj = course.getProjects().newProject(
                            project.getId());
                    proj.getDescription().setTitle(
                            project.getDescription().getTitle());
                    proj.getDescription().setBody(
                            project.getDescription().getBody());
                    proj.updateNameInTree();
                    io.saveProject(proj);
                    io.saveProjectsInclude(course.getProjects());
                    // reloading tree...
                    top = new DefaultMutableTreeNode(tree.getNameInTree());
                    createNodes(top);
                    DefaultTreeModel model = (DefaultTreeModel) jTree
                            .getModel();
                    model.setRoot(top);
                    TreePath path = jTree.getNextMatch(course.getNameInTree(),
                            0, Position.Bias.Forward);
                    System.out.println(path);
                    jTree.setSelectionPath(path);
                } catch (IOException ex) {
                    JOptionPane.showMessageDialog(this,
                            "Can't create XML file for new project.");
                    ex.printStackTrace();
                } catch (NullPointerException ex) {
                    ex.printStackTrace();
                } catch (Exception ex) {
                    JOptionPane.showMessageDialog(this,
                            "Cannot save the project " + ex,
                            "Cannot save the project " + ex,
                            JOptionPane.ERROR_MESSAGE);
                    ex.printStackTrace();
                }
                break;
            // lectures selected
            case 11:
                try {
                    // creating new course
                    course = tree.newCourse(newId);
                    course.updateNameInTree();
                    io.saveCourse(course);
                    for (Lecture lecture : old_course.getLectures()
                            .getLectures()) {
                        // copying lecture
                        Lecture lect = course.getLectures().newLecture(
                                lecture.getId());
                        lect.getDescription().setTitle(
                                lecture.getDescription().getTitle());
                        lect.getDescription().setBody(
                                lecture.getDescription().getBody());
                        lect.updateNameInTree();
                        io.saveLecture(lect);
                    }
                    // savaing include-file
                    io.saveLecturesInclude(course.getLectures());
                    // reloading tree...
                    top = new DefaultMutableTreeNode(tree.getNameInTree());
                    createNodes(top);
                    DefaultTreeModel model = (DefaultTreeModel) jTree
                            .getModel();
                    model.setRoot(top);
                    TreePath path = jTree.getNextMatch(course.getNameInTree(),
                            0, Position.Bias.Forward);
                    System.out.println(path);
                    jTree.setSelectionPath(path);
                } catch (IOException ex) {
                    JOptionPane.showMessageDialog(this,
                            "Can't create XML file for new lecture.");
                } catch (Exception ex) {
                    JOptionPane.showMessageDialog(this,
                            "Cannot save the lecture " + ex,
                            "Cannot save the lecture " + ex,
                            JOptionPane.ERROR_MESSAGE);
                }
                break;
            // tasks selected
            case 22:
                try {
                    // creating new course
                    course = tree.newCourse(newId);
                    course.updateNameInTree();
                    io.saveCourse(course);
                    for (Task task : old_course.getTasks().getTasks()) {
                        // copying task
                        Task tas = course.getTasks().newTask(task.getId());
                        tas.getDescription().setTitle(
                                task.getDescription().getTitle());
                        tas.getDescription().setBody(
                                task.getDescription().getBody());
                        tas.updateNameInTree();
                        io.saveTask(tas);
                    }
                    // savaing include-file
                    io.saveTasksInclude(course.getTasks());
                    // reloading tree...
                    top = new DefaultMutableTreeNode(tree.getNameInTree());
                    createNodes(top);
                    DefaultTreeModel model = (DefaultTreeModel) jTree
                            .getModel();
                    model.setRoot(top);
                    TreePath path = jTree.getNextMatch(course.getNameInTree(),
                            0, Position.Bias.Forward);
                    System.out.println(path);
                    jTree.setSelectionPath(path);
                } catch (IOException ex) {
                    JOptionPane.showMessageDialog(this,
                            "Can't create XML file for new task.");
                } catch (Exception ex) {
                    JOptionPane.showMessageDialog(this, "Cannot save the task "
                            + ex, "Cannot save the task " + ex,
                            JOptionPane.ERROR_MESSAGE);
                }
                break;
            // practices selected
            case 33:
                try {
                    // creating new course
                    course = tree.newCourse(newId);
                    course.updateNameInTree();
                    io.saveCourse(course);
                    for (Practice practice : old_course.getPractices()
                            .getPractices()) {
                        // copying practice
                        Practice prac = course.getPractices().newPractice(
                                practice.getId());
                        prac.getDescription().setTitle(
                                practice.getDescription().getTitle());
                        prac.getDescription().setBody(
                                practice.getDescription().getBody());
                        prac.updateNameInTree();
                        io.savePractice(prac);
                    }
                    // savaing include-file
                    io.savePracticesInclude(course.getPractices());
                    // reloading tree...
                    top = new DefaultMutableTreeNode(tree.getNameInTree());
                    createNodes(top);
                    DefaultTreeModel model = (DefaultTreeModel) jTree
                            .getModel();
                    model.setRoot(top);
                    TreePath path = jTree.getNextMatch(course.getNameInTree(),
                            0, Position.Bias.Forward);
                    System.out.println(path);
                    jTree.setSelectionPath(path);
                } catch (IOException ex) {
                    JOptionPane.showMessageDialog(this,
                            "Can't create XML file for new practice.");
                } catch (Exception ex) {
                    JOptionPane.showMessageDialog(this,
                            "Cannot save the practice " + ex,
                            "Cannot save the practice " + ex,
                            JOptionPane.ERROR_MESSAGE);
                }
                break;
            // projects selected
            case 44:
                try {
                    // creating new course
                    course = tree.newCourse(newId);
                    course.updateNameInTree();
                    io.saveCourse(course);
                    for (Project project : old_course.getProjects()
                            .getProjects()) {
                        // copying project
                        Project proj = course.getProjects().newProject(
                                project.getId());
                        proj.getDescription().setTitle(
                                project.getDescription().getTitle());
                        proj.getDescription().setBody(
                                project.getDescription().getBody());
                        proj.updateNameInTree();
                        io.saveProject(proj);
                    }
                    // savaing include-file
                    io.saveProjectsInclude(course.getProjects());
                    // reloading tree...
                    top = new DefaultMutableTreeNode(tree.getNameInTree());
                    createNodes(top);
                    DefaultTreeModel model = (DefaultTreeModel) jTree
                            .getModel();
                    model.setRoot(top);
                    TreePath path = jTree.getNextMatch(course.getNameInTree(),
                            0, Position.Bias.Forward);
                    System.out.println(path);
                    jTree.setSelectionPath(path);
                } catch (IOException ex) {
                    JOptionPane.showMessageDialog(this,
                            "Can't create XML file for new project.");
                } catch (Exception ex) {
                    JOptionPane.showMessageDialog(this,
                            "Cannot save the project " + ex,
                            "Cannot save the project " + ex,
                            JOptionPane.ERROR_MESSAGE);
                }
                break;
            // error
            default:
                System.out.println("Error selecting item for new item...");
                System.out.println("-> jButtonAddActionPerformed");
            }
        }
    }//GEN-LAST:event_jButtonCopyToNewActionPerformed

    private void jButtonAddCopyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAddCopyActionPerformed
        Course old_course = course;
        course = tree.getCourse((String) jComboBoxCourseCopy.getSelectedItem());
        String newId;
        switch (selected) {
        // lecture selected
        case 1:
            try {
                newId = lecture.getId();
                // lecture with ID exists?
                while (course.getLectures().getLecture(newId) != null) {
                    JOptionPane.showMessageDialog(this, "Lecture with ID "
                            + newId + " already exists. Please type new ID.");
                    newId = JOptionPane.showInputDialog("New id for lecture: ");
                }
                // copying lecture
                Lecture lect = course.getLectures().newLecture(newId);
                lect.getDescription().setTitle(
                        lecture.getDescription().getTitle());
                lect.getDescription().setBody(
                        lecture.getDescription().getBody());
                lect.updateNameInTree();
                io.saveLecture(lect);
                io.saveLecturesInclude(course.getLectures());
                // adding node
                DefaultTreeModel model = (DefaultTreeModel) jTree.getModel();
                TreePath path;
                if (course.getId() != old_course.getId()) {
                    path = jTree.getNextMatch(course.getNameInTree(), 0,
                            Position.Bias.Forward);
                } else {
                    path = jTree.getSelectionPath().getParentPath()
                            .getParentPath();
                }
                // 0 for lectures, 1 for tasks etc.
                path = path.pathByAddingChild(model.getChild(path
                        .getLastPathComponent(), 0));

                MutableTreeNode node = (MutableTreeNode) path
                        .getLastPathComponent();
                // selecting lectures in tree
                jTree.setSelectionPath(path);
                // removing all nodes (sorting problem)
                while (node.getChildCount() > 0) {
                    model.removeNodeFromParent((MutableTreeNode) node
                            .getChildAt(0));
                }
                // adding all nodes
                for (Lecture l : course.getLectures().getLectures()) {
                    MutableTreeNode newNode = new DefaultMutableTreeNode(l
                            .getNameInTree());
                    model.insertNodeInto(newNode, node, node.getChildCount());
                }

            } catch (IOException ex) {
                JOptionPane.showMessageDialog(this,
                        "Can't create XML file for new lecture.");
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(this, "Cannot save the lecture "
                        + ex, "Cannot save the lecture " + ex,
                        JOptionPane.ERROR_MESSAGE);
            }
            break;
        // task selected
        case 2:
            try {
                newId = task.getId();
                // task with ID exists?
                while (course.getTasks().getTask(newId) != null) {
                    JOptionPane.showMessageDialog(this, "Task with ID " + newId
                            + " already exists. Please type new ID.");
                    newId = JOptionPane.showInputDialog("New id for task: ");
                }
                // copying task
                Task tas = course.getTasks().newTask(newId);
                tas.getDescription().setTitle(task.getDescription().getTitle());
                tas.getDescription().setBody(task.getDescription().getBody());
                tas.updateNameInTree();
                io.saveTask(tas);
                io.saveTasksInclude(course.getTasks());
                // adding node
                DefaultTreeModel model = (DefaultTreeModel) jTree.getModel();
                TreePath path;
                if (course.getId() != old_course.getId()) {
                    path = jTree.getNextMatch(course.getNameInTree(), 0,
                            Position.Bias.Forward);
                } else {
                    path = jTree.getSelectionPath().getParentPath()
                            .getParentPath();
                }
                // 0 for lectures, 1 for tasks etc.
                path = path.pathByAddingChild(model.getChild(path
                        .getLastPathComponent(), 1));

                MutableTreeNode node = (MutableTreeNode) path
                        .getLastPathComponent();
                // selecting tasks in tree
                jTree.setSelectionPath(path);
                // removing all nodes (sorting problem)
                while (node.getChildCount() > 0) {
                    model.removeNodeFromParent((MutableTreeNode) node
                            .getChildAt(0));
                }
                // adding all nodes
                for (Task t : course.getTasks().getTasks()) {
                    MutableTreeNode newNode = new DefaultMutableTreeNode(t
                            .getNameInTree());
                    model.insertNodeInto(newNode, node, node.getChildCount());
                }

            } catch (IOException ex) {
                JOptionPane.showMessageDialog(this,
                        "Can't create XML file for new task.");
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(this, "Cannot save the task "
                        + ex, "Cannot save the task " + ex,
                        JOptionPane.ERROR_MESSAGE);
            }
            break;
        // practice selected
        case 3:
            try {
                newId = practice.getId();
                // practice with ID exists?
                while (course.getPractices().getPractice(newId) != null) {
                    JOptionPane.showMessageDialog(this, "Practice with ID "
                            + newId + " already exists. Please type new ID.");
                    newId = JOptionPane
                            .showInputDialog("New id for practice: ");
                }
                // copying practice
                Practice prac = course.getPractices().newPractice(newId);
                prac.getDescription().setTitle(
                        practice.getDescription().getTitle());
                prac.getDescription().setBody(
                        practice.getDescription().getBody());
                prac.updateNameInTree();
                io.savePractice(prac);
                io.savePracticesInclude(course.getPractices());
                // adding node
                DefaultTreeModel model = (DefaultTreeModel) jTree.getModel();
                TreePath path;
                if (course.getId() != old_course.getId()) {
                    path = jTree.getNextMatch(course.getNameInTree(), 0,
                            Position.Bias.Forward);
                } else {
                    path = jTree.getSelectionPath().getParentPath()
                            .getParentPath();
                }
                // 0 for lectures, 1 for tasks etc.
                path = path.pathByAddingChild(model.getChild(path
                        .getLastPathComponent(), 2));

                MutableTreeNode node = (MutableTreeNode) path
                        .getLastPathComponent();
                // selecting practices in tree
                jTree.setSelectionPath(path);
                // removing all nodes (sorting problem)
                while (node.getChildCount() > 0) {
                    model.removeNodeFromParent((MutableTreeNode) node
                            .getChildAt(0));
                }
                // adding all nodes
                for (Practice p : course.getPractices().getPractices()) {
                    MutableTreeNode newNode = new DefaultMutableTreeNode(p
                            .getNameInTree());
                    model.insertNodeInto(newNode, node, node.getChildCount());
                }

            } catch (IOException ex) {
                JOptionPane.showMessageDialog(this,
                        "Can't create XML file for new practice.");
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(this, "Cannot save the practice "
                        + ex, "Cannot save the practice " + ex,
                        JOptionPane.ERROR_MESSAGE);
            }
            break;
        // project selected
        case 4:
            try {
                newId = project.getId();
                // project with ID exists?
                while (course.getProjects().getProject(newId) != null) {
                    JOptionPane.showMessageDialog(this, "Project with ID "
                            + newId + " already exists. Please type new ID.");
                    newId = JOptionPane.showInputDialog("New id for project: ");
                }
                // copying project
                Project proj = course.getProjects().newProject(newId);
                proj.getDescription().setTitle(
                        project.getDescription().getTitle());
                proj.getDescription().setBody(
                        project.getDescription().getBody());
                proj.updateNameInTree();
                io.saveProject(proj);
                io.saveProjectsInclude(course.getProjects());
                // adding node
                DefaultTreeModel model = (DefaultTreeModel) jTree.getModel();
                TreePath path;
                if (course.getId() != old_course.getId()) {
                    path = jTree.getNextMatch(course.getNameInTree(), 0,
                            Position.Bias.Forward);
                } else {
                    path = jTree.getSelectionPath().getParentPath()
                            .getParentPath();
                }
                // 0 for lectures, 1 for tasks etc.
                path = path.pathByAddingChild(model.getChild(path
                        .getLastPathComponent(), 3));

                MutableTreeNode node = (MutableTreeNode) path
                        .getLastPathComponent();
                // selecting projects in tree
                jTree.setSelectionPath(path);
                // removing all nodes (sorting problem)
                while (node.getChildCount() > 0) {
                    model.removeNodeFromParent((MutableTreeNode) node
                            .getChildAt(0));
                }
                // adding all nodes
                for (Project p : course.getProjects().getProjects()) {
                    MutableTreeNode newNode = new DefaultMutableTreeNode(p
                            .getNameInTree());
                    model.insertNodeInto(newNode, node, node.getChildCount());
                }

            } catch (IOException ex) {
                JOptionPane.showMessageDialog(this,
                        "Can't create XML file for new project.");
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(this, "Cannot save the project "
                        + ex, "Cannot save the project " + ex,
                        JOptionPane.ERROR_MESSAGE);
            }
            break;
        // lectures selected
        case 11:
            try {
                for (Lecture lecture : old_course.getLectures().getLectures()) {
                    newId = lecture.getId();
                    // lecture with ID exists?
                    while (course.getLectures().getLecture(newId) != null) {
                        JOptionPane.showMessageDialog(this, "Lecture with ID "
                                + newId
                                + " already exists. Please type new ID.");
                        newId = JOptionPane
                                .showInputDialog("New id for lecture: ");
                    }
                    // copying lecture
                    Lecture lect = course.getLectures().newLecture(newId);
                    lect.getDescription().setTitle(
                            lecture.getDescription().getTitle());
                    lect.getDescription().setBody(
                            lecture.getDescription().getBody());
                    lect.updateNameInTree();
                    io.saveLecture(lect);
                    io.saveLecturesInclude(course.getLectures());

                    // adding node
                    DefaultTreeModel model = (DefaultTreeModel) jTree
                            .getModel();
                    TreePath path;
                    if (course.getId() != old_course.getId()) {
                        path = jTree.getNextMatch(course.getNameInTree(), 0,
                                Position.Bias.Forward);
                    } else {
                        path = jTree.getSelectionPath().getParentPath()
                                .getParentPath();
                    }
                    // 0 for lectures, 1 for tasks etc.
                    path = path.pathByAddingChild(model.getChild(path
                            .getLastPathComponent(), 0));

                    MutableTreeNode node = (MutableTreeNode) path
                            .getLastPathComponent();
                    // selecting lectures in tree
                    jTree.setSelectionPath(path);
                    // removing all nodes (sorting problem)
                    while (node.getChildCount() > 0) {
                        model.removeNodeFromParent((MutableTreeNode) node
                                .getChildAt(0));
                    }
                    // adding all nodes
                    for (Lecture l : course.getLectures().getLectures()) {
                        MutableTreeNode newNode = new DefaultMutableTreeNode(l
                                .getNameInTree());
                        model.insertNodeInto(newNode, node, node
                                .getChildCount());
                    }
                }
            } catch (IOException ex) {
                JOptionPane.showMessageDialog(this,
                        "Can't create XML file for new lecture.");
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(this, "Cannot save the lecture "
                        + ex, "Cannot save the lecture " + ex,
                        JOptionPane.ERROR_MESSAGE);
            }
            break;
        // tasks selected
        case 22:
            try {
                for (Task task : old_course.getTasks().getTasks()) {
                    newId = task.getId();
                    // task with ID exists?
                    while (course.getTasks().getTask(newId) != null) {
                        JOptionPane.showMessageDialog(this, "Task with ID "
                                + newId

                                + " already exists. Please type new ID.");
                        newId = JOptionPane
                                .showInputDialog("New id for task: ");
                    }
                    // copying task
                    Task tas = course.getTasks().newTask(newId);
                    tas.getDescription().setTitle(
                            task.getDescription().getTitle());
                    tas.getDescription().setBody(
                            task.getDescription().getBody());
                    tas.updateNameInTree();
                    io.saveTask(tas);
                    io.saveTasksInclude(course.getTasks());

                    // adding node
                    DefaultTreeModel model = (DefaultTreeModel) jTree
                            .getModel();
                    TreePath path;
                    if (course.getId() != old_course.getId()) {
                        path = jTree.getNextMatch(course.getNameInTree(), 0,
                                Position.Bias.Forward);
                    } else {
                        path = jTree.getSelectionPath().getParentPath()
                                .getParentPath();
                    }
                    // 0 for lectures, 1 for tasks etc.
                    path = path.pathByAddingChild(model.getChild(path
                            .getLastPathComponent(), 1));

                    MutableTreeNode node = (MutableTreeNode) path
                            .getLastPathComponent();
                    // selecting tasks in tree
                    jTree.setSelectionPath(path);
                    // removing all nodes (sorting problem)
                    while (node.getChildCount() > 0) {
                        model.removeNodeFromParent((MutableTreeNode) node
                                .getChildAt(0));
                    }
                    // adding all nodes
                    for (Task t : course.getTasks().getTasks()) {
                        MutableTreeNode newNode = new DefaultMutableTreeNode(t
                                .getNameInTree());
                        model.insertNodeInto(newNode, node, node
                                .getChildCount());
                    }
                }
            } catch (IOException ex) {
                JOptionPane.showMessageDialog(this,
                        "Can't create XML file for new task.");
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(this, "Cannot save the task "
                        + ex, "Cannot save the task " + ex,
                        JOptionPane.ERROR_MESSAGE);
            }
            break;
        // practices selected
        case 33:
            try {
                for (Practice practice : old_course.getPractices()
                        .getPractices()) {
                    newId = practice.getId();
                    // practice with ID exists?
                    while (course.getPractices().getPractice(newId) != null) {
                        JOptionPane.showMessageDialog(this, "Practice with ID "
                                + newId
                                + " already exists. Please type new ID.");
                        newId = JOptionPane
                                .showInputDialog("New id for practice: ");
                    }
                    // copying practice
                    Practice prac = course.getPractices().newPractice(newId);
                    prac.getDescription().setTitle(
                            practice.getDescription().getTitle());
                    prac.getDescription().setBody(
                            practice.getDescription().getBody());
                    prac.updateNameInTree();
                    io.savePractice(prac);
                    io.savePracticesInclude(course.getPractices());

                    // adding node
                    DefaultTreeModel model = (DefaultTreeModel) jTree
                            .getModel();
                    TreePath path;
                    if (course.getId() != old_course.getId()) {
                        path = jTree.getNextMatch(course.getNameInTree(), 0,
                                Position.Bias.Forward);
                    } else {
                        path = jTree.getSelectionPath().getParentPath()
                                .getParentPath();
                    }
                    // 0 for lectures, 1 for tasks etc.
                    path = path.pathByAddingChild(model.getChild(path
                            .getLastPathComponent(), 2));

                    MutableTreeNode node = (MutableTreeNode) path
                            .getLastPathComponent();
                    // selecting practices in tree
                    jTree.setSelectionPath(path);
                    // removing all nodes (sorting problem)
                    while (node.getChildCount() > 0) {
                        model.removeNodeFromParent((MutableTreeNode) node
                                .getChildAt(0));
                    }
                    // adding all nodes
                    for (Practice l : course.getPractices().getPractices()) {
                        MutableTreeNode newNode = new DefaultMutableTreeNode(l
                                .getNameInTree());
                        model.insertNodeInto(newNode, node, node
                                .getChildCount());
                    }
                }
            } catch (IOException ex) {
                JOptionPane.showMessageDialog(this,
                        "Can't create XML file for new practice.");
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(this, "Cannot save the practice "
                        + ex, "Cannot save the practice " + ex,
                        JOptionPane.ERROR_MESSAGE);
            }
            break;
        // projects selected
        case 44:
            try {
                for (Project project : old_course.getProjects().getProjects()) {
                    newId = project.getId();
                    // project with ID exists?
                    while (course.getProjects().getProject(newId) != null) {
                        JOptionPane.showMessageDialog(this, "Project with ID "
                                + newId
                                + " already exists. Please type new ID.");
                        newId = JOptionPane
                                .showInputDialog("New id for project: ");
                    }
                    // copying project
                    Project proj = course.getProjects().newProject(newId);
                    proj.getDescription().setTitle(
                            project.getDescription().getTitle());
                    proj.getDescription().setBody(
                            project.getDescription().getBody());
                    proj.updateNameInTree();
                    io.saveProject(proj);
                    io.saveProjectsInclude(course.getProjects());

                    // adding node
                    DefaultTreeModel model = (DefaultTreeModel) jTree
                            .getModel();
                    TreePath path;
                    if (course.getId() != old_course.getId()) {
                        path = jTree.getNextMatch(course.getNameInTree(), 0,
                                Position.Bias.Forward);
                    } else {
                        path = jTree.getSelectionPath().getParentPath()
                                .getParentPath();
                    }
                    // 0 for lectures, 1 for tasks etc.
                    path = path.pathByAddingChild(model.getChild(path
                            .getLastPathComponent(), 3));

                    MutableTreeNode node = (MutableTreeNode) path
                            .getLastPathComponent();
                    // selecting projects in tree
                    jTree.setSelectionPath(path);
                    // removing all nodes (sorting problem)
                    while (node.getChildCount() > 0) {
                        model.removeNodeFromParent((MutableTreeNode) node
                                .getChildAt(0));
                    }
                    // adding all nodes
                    for (Project p : course.getProjects().getProjects()) {
                        MutableTreeNode newNode = new DefaultMutableTreeNode(p
                                .getNameInTree());
                        model.insertNodeInto(newNode, node, node
                                .getChildCount());
                    }
                }
            } catch (IOException ex) {
                JOptionPane.showMessageDialog(this,
                        "Can't create XML file for new project.");
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(this, "Cannot save the project "
                        + ex, "Cannot save the project " + ex,
                        JOptionPane.ERROR_MESSAGE);
            }
            break;
        // error
        default:
            System.out.println("Error selecting item for new item...");
            System.out.println("-> jButtonAddActionPerformed");
        }
        jFrameCopy.setVisible(false);
    }//GEN-LAST:event_jButtonAddCopyActionPerformed

    private void jButtonCancelCopyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCancelCopyActionPerformed
        jFrameCopy.setVisible(false);
    }//GEN-LAST:event_jButtonCancelCopyActionPerformed

    private void jButtonCopyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCopyActionPerformed
        switch (selected) {
        // lecture selected
        case 1:
            jLabelCourseCopy.setText("Select course for lecture copy");
            jFrameCopy.setTitle("Select course for lecture copy");
            break;
        // task selected
        case 2:
            jFrameCopy.setTitle("Select course for task copy");
            jLabelCourseCopy.setText("Select course for task copy");
            break;
        // practice selected
        case 3:
            jFrameCopy.setTitle("Select course for practice copy");
            jLabelCourseCopy.setText("Select course for practice copy");
            break;
        // project selected
        case 4:
            jFrameCopy.setTitle("Select course for project copy");
            jLabelCourseCopy.setText("Select course for project copy");
            break;
        // lectures selected
        case 11:
            jFrameCopy.setTitle("Select course for lecture copies");
            jLabelCourseCopy.setText("Select course for lecture copies");
            break;
        // tasks selected
        case 22:
            jFrameCopy.setTitle("Select course for task copies");
            jLabelCourseCopy.setText("Select course for lecture copies");
            break;
        // practices selected
        case 33:
            jFrameCopy.setTitle("Select course for practice copies");
            jLabelCourseCopy.setText("Select course for lecture copies");
            break;
        // projects selected
        case 44:
            jFrameCopy.setTitle("Select course for project copies");
            jLabelCourseCopy.setText("Select course for lecture copies");
            break;
        // error
        default:
            System.out.println("Error selecting item for new item...");
            System.out.println("-> jButtonCopyActionPerformed");
        }
        switch (selected) {
        case 1:
        case 2:
        case 3:
        case 4:
            jFrameCopy.setVisible(true);
            jFrameCopy.setSize(250, 120);
            jComboBoxCourseCopy.removeAllItems();
            // to know what index is added
            int i = 0;
            for (Course c : tree.getCourses()) {
                jComboBoxCourseCopy.addItem(c.getId());
                // selecting the current course
                if (c.getId() == course.getId()) {
                    jComboBoxCourseCopy.setSelectedIndex(i);
                }
                i++;
            }
            break;
        case 11:
        case 22:
        case 33:
        case 44:
            jFrameCopy.setVisible(true);
            jFrameCopy.setSize(250, 120);
            jComboBoxCourseCopy.removeAllItems();
            // to know what index is added
            for (Course c : tree.getCourses()) {
                if (c.getId() != course.getId()) {
                    jComboBoxCourseCopy.addItem(c.getId());
                }
            }
            break;
        default:
            System.out.println("Error selecting item for new item...");
            System.out.println("-> jButtonCopyActionPerformed (part 2)");
        }

    }//GEN-LAST:event_jButtonCopyActionPerformed

    private void jRMenuLookDefaultActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRMenuLookDefaultActionPerformed
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
            SwingUtilities.updateComponentTreeUI(this);
            this.pack();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        jRMenuLookWindows.setSelected(false);
        jRMenuLookGTK.setSelected(false);
        jRMenuLookLinux.setSelected(false);
        jRMenuLookJava.setSelected(false);
        jRMenuLookDefault.setSelected(true);
        jRMenuLookCross.setSelected(false);
    }//GEN-LAST:event_jRMenuLookDefaultActionPerformed

    private void jRMenuLookLinuxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRMenuLookLinuxActionPerformed
        try {
            UIManager
                    .setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
            SwingUtilities.updateComponentTreeUI(this);
            this.pack();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        jRMenuLookWindows.setSelected(false);
        jRMenuLookGTK.setSelected(false);
        jRMenuLookLinux.setSelected(true);
        jRMenuLookJava.setSelected(false);
        jRMenuLookDefault.setSelected(false);
        jRMenuLookCross.setSelected(false);
    }//GEN-LAST:event_jRMenuLookLinuxActionPerformed

    private void jRMenuLookGTKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRMenuLookGTKActionPerformed
        try {
            UIManager
                    .setLookAndFeel("com.sun.java.swing.plaf.gtk.GTKLookAndFeel");
            SwingUtilities.updateComponentTreeUI(this);
            this.pack();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        jRMenuLookWindows.setSelected(false);
        jRMenuLookGTK.setSelected(true);
        jRMenuLookLinux.setSelected(false);
        jRMenuLookJava.setSelected(false);
        jRMenuLookDefault.setSelected(false);
        jRMenuLookCross.setSelected(false);
    }//GEN-LAST:event_jRMenuLookGTKActionPerformed

    private void jRMenuLookJavaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRMenuLookJavaActionPerformed
        try {
            UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
            SwingUtilities.updateComponentTreeUI(this);
            this.pack();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        jRMenuLookWindows.setSelected(false);
        jRMenuLookGTK.setSelected(false);
        jRMenuLookLinux.setSelected(false);
        jRMenuLookJava.setSelected(true);
        jRMenuLookDefault.setSelected(false);
        jRMenuLookCross.setSelected(false);
    }//GEN-LAST:event_jRMenuLookJavaActionPerformed

    private void jRMenuLookWindowsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRMenuLookWindowsActionPerformed
        try {
            UIManager
                    .setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
            SwingUtilities.updateComponentTreeUI(this);
            this.pack();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        jRMenuLookWindows.setSelected(true);
        jRMenuLookGTK.setSelected(false);
        jRMenuLookLinux.setSelected(false);
        jRMenuLookJava.setSelected(false);
        jRMenuLookDefault.setSelected(false);
        jRMenuLookCross.setSelected(false);
    }//GEN-LAST:event_jRMenuLookWindowsActionPerformed

    private void jRMenuLookCrossActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRMenuLookCrossActionPerformed
        try {
            UIManager.setLookAndFeel(UIManager
                    .getCrossPlatformLookAndFeelClassName());
            SwingUtilities.updateComponentTreeUI(this);
            this.pack();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        jRMenuLookWindows.setSelected(false);
        jRMenuLookGTK.setSelected(false);
        jRMenuLookLinux.setSelected(false);
        jRMenuLookJava.setSelected(false);
        jRMenuLookDefault.setSelected(false);
        jRMenuLookCross.setSelected(true);
    }//GEN-LAST:event_jRMenuLookCrossActionPerformed

    private void jMenuLookActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuLookActionPerformed

    }//GEN-LAST:event_jMenuLookActionPerformed

    private void miNewProjectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miNewProjectActionPerformed
        jFrameNew.setVisible(true);
        jFrameNew.setTitle("Add new project");
        jFrameNew.setSize(250, 180);
        jLabelCourse.setText("Select course for new project:");
        jLabelNewId.setText("New project's ID:");
        jComboBoxCourse.removeAllItems();
        // to know what index is added
        int i = 0;
        for (Course c : tree.getCourses()) {
            jComboBoxCourse.addItem(c.getId());
            // selecting the current course
            if (c.getId() == course.getId()) {
                jComboBoxCourse.setSelectedIndex(i);
            }
            i++;
        }
        selected = 4;
    }//GEN-LAST:event_miNewProjectActionPerformed

    private void miNewPracticeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miNewPracticeActionPerformed
        jFrameNew.setVisible(true);
        jFrameNew.setTitle("Add new practice");
        jFrameNew.setSize(250, 180);
        jLabelCourse.setText("Select course for new practice:");
        jLabelNewId.setText("New practice's ID:");
        jComboBoxCourse.removeAllItems();
        // to know what index is added
        int i = 0;
        for (Course c : tree.getCourses()) {
            jComboBoxCourse.addItem(c.getId());
            // selecting the current course
            if (c.getId() == course.getId()) {
                jComboBoxCourse.setSelectedIndex(i);
            }
            i++;
        }
        selected = 3;
    }//GEN-LAST:event_miNewPracticeActionPerformed

    private void miNewTaskActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miNewTaskActionPerformed
        jFrameNew.setVisible(true);
        jFrameNew.setTitle("Add new task");
        jFrameNew.setSize(250, 180);
        jLabelCourse.setText("Select course for new task:");
        jLabelNewId.setText("New task's ID:");
        jComboBoxCourse.removeAllItems();
        // to know what index is added
        int i = 0;
        for (Course c : tree.getCourses()) {
            jComboBoxCourse.addItem(c.getId());
            // selecting the current course
            if (c.getId() == course.getId()) {
                jComboBoxCourse.setSelectedIndex(i);
            }
            i++;
        }
        selected = 2;
    }//GEN-LAST:event_miNewTaskActionPerformed

    private void jButtonAddNewActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAddNewActionPerformed
        String newId = jTextFieldNewId.getText();
        course = tree.getCourse((String) jComboBoxCourse.getSelectedItem());
        if (newId == "") {
            JOptionPane.showMessageDialog(this,
                    "Please insert new lecture's ID!");
            jFrameNew.setVisible(true);
        } else {
            switch (selected) {
            // lecture selected
            case 1:
                try {
                    Lecture lect = course.getLectures().newLecture(newId);
                    io.saveLecture(lect);
                    io.saveLecturesInclude(course.getLectures());
                    // adding node
                    DefaultTreeModel model = (DefaultTreeModel) jTree
                            .getModel();
                    TreePath path = jTree.getNextMatch(course.getNameInTree(),
                            0, Position.Bias.Forward);
                    // 0 for lectures, 1 for tasks etc.
                    path = path.pathByAddingChild(model.getChild(path
                            .getLastPathComponent(), 0));
                    MutableTreeNode node = (MutableTreeNode) path
                            .getLastPathComponent();
                    // removing all nodes (sorting problem)
                    while (node.getChildCount() > 0) {
                        model.removeNodeFromParent((MutableTreeNode) node
                                .getChildAt(0));
                    }
                    // adding all nodes
                    for (Lecture l : course.getLectures().getLectures()) {
                        MutableTreeNode newNode = new DefaultMutableTreeNode(l
                                .getNameInTree());
                        model.insertNodeInto(newNode, node, node
                                .getChildCount());
                    }

                } catch (IOException ex) {
                    JOptionPane.showMessageDialog(this,
                            "Can't create XML file for new lecture.");
                } catch (Exception ex) {
                    JOptionPane.showMessageDialog(this,
                            "Cannot save the lecture " + ex,
                            "Cannot save the lecture " + ex,
                            JOptionPane.ERROR_MESSAGE);
                }
                break;
            // task selected
            case 2:
                try {
                    Task tas = course.getTasks().newTask(newId);
                    io.saveTask(tas);
                    io.saveTasksInclude(course.getTasks());

                    // adding node
                    DefaultTreeModel model = (DefaultTreeModel) jTree
                            .getModel();
                    TreePath path = jTree.getNextMatch(course.getNameInTree(),
                            0, Position.Bias.Forward);
                    // 0 for lectures, 1 for tasks etc.
                    path = path.pathByAddingChild(model.getChild(path
                            .getLastPathComponent(), 1));
                    MutableTreeNode node = (MutableTreeNode) path
                            .getLastPathComponent();
                    // removing all nodes (sorting problem)
                    while (node.getChildCount() > 0) {
                        model.removeNodeFromParent((MutableTreeNode) node
                                .getChildAt(0));
                    }
                    // adding all nodes
                    for (Task t : course.getTasks().getTasks()) {
                        MutableTreeNode newNode = new DefaultMutableTreeNode(t
                                .getNameInTree());
                        model.insertNodeInto(newNode, node, node
                                .getChildCount());
                    }
                } catch (IOException ex) {
                    JOptionPane.showMessageDialog(this,
                            "Can't create XML file for new task.");
                } catch (Exception ex) {
                    JOptionPane.showMessageDialog(this, "Cannot save the task "
                            + ex, "Cannot save the task " + ex,
                            JOptionPane.ERROR_MESSAGE);
                }
                break;
            // practice selected
            case 3:
                try {
                    Practice prac = course.getPractices().newPractice(newId);
                    io.savePractice(prac);
                    io.savePracticesInclude(course.getPractices());
                    // adding node
                    DefaultTreeModel model = (DefaultTreeModel) jTree
                            .getModel();
                    TreePath path = jTree.getNextMatch(course.getNameInTree(),
                            0, Position.Bias.Forward);
                    // 0 for lectures, 1 for tasks etc.
                    path = path.pathByAddingChild(model.getChild(path
                            .getLastPathComponent(), 2));
                    MutableTreeNode node = (MutableTreeNode) path
                            .getLastPathComponent();
                    // removing all nodes (sorting problem)
                    while (node.getChildCount() > 0) {
                        model.removeNodeFromParent((MutableTreeNode) node
                                .getChildAt(0));
                    }
                    // adding all nodes
                    for (Practice p : course.getPractices().getPractices()) {
                        MutableTreeNode newNode = new DefaultMutableTreeNode(p
                                .getNameInTree());
                        model.insertNodeInto(newNode, node, node
                                .getChildCount());
                    }
                } catch (IOException ex) {
                    JOptionPane.showMessageDialog(this,
                            "Can't create XML file for new practice.");
                } catch (Exception ex) {
                    JOptionPane.showMessageDialog(this,
                            "Cannot save the practice " + ex,
                            "Cannot save the practice " + ex,
                            JOptionPane.ERROR_MESSAGE);
                }
                break;
            // project selected
            case 4:
                try {
                    Project proj = course.getProjects().newProject(newId);
                    io.saveProject(proj);
                    io.saveProjectsInclude(course.getProjects());
                    // adding node
                    DefaultTreeModel model = (DefaultTreeModel) jTree
                            .getModel();
                    TreePath path = jTree.getNextMatch(course.getNameInTree(),
                            0, Position.Bias.Forward);
                    // 0 for lectures, 1 for tasks etc.
                    path = path.pathByAddingChild(model.getChild(path
                            .getLastPathComponent(), 3));
                    MutableTreeNode node = (MutableTreeNode) path
                            .getLastPathComponent();
                    // removing all nodes (sorting problem)
                    while (node.getChildCount() > 0) {
                        model.removeNodeFromParent((MutableTreeNode) node
                                .getChildAt(0));
                    }
                    // adding all nodes
                    for (Project p : course.getProjects().getProjects()) {
                        MutableTreeNode newNode = new DefaultMutableTreeNode(p
                                .getNameInTree());
                        model.insertNodeInto(newNode, node, node
                                .getChildCount());
                    }
                } catch (IOException ex) {
                    JOptionPane.showMessageDialog(this,
                            "Can't create XML file for new task.");
                } catch (Exception ex) {
                    JOptionPane.showMessageDialog(this, "Cannot save the task "
                            + ex, "Cannot save the task " + ex,
                            JOptionPane.ERROR_MESSAGE);
                }
                break;
            }
            jFrameNew.setVisible(false);
        }
    }//GEN-LAST:event_jButtonAddNewActionPerformed

    private void jButtonCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCancelActionPerformed
        jFrameNew.setVisible(false);
    }//GEN-LAST:event_jButtonCancelActionPerformed

    private void miNewLectureActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miNewLectureActionPerformed
        jFrameNew.setVisible(true);
        jFrameNew.setTitle("Add new lecture");
        jFrameNew.setSize(250, 180);
        jLabelCourse.setText("Select course for new lecture:");
        jLabelNewId.setText("New lecture's ID:");
        jComboBoxCourse.removeAllItems();
        // to know what index is added
        int i = 0;
        for (Course c : tree.getCourses()) {
            jComboBoxCourse.addItem(c.getId());
            // selecting the current course
            if (c.getId() == course.getId()) {
                jComboBoxCourse.setSelectedIndex(i);
            }
            i++;
        }
        selected = 1;
    }//GEN-LAST:event_miNewLectureActionPerformed

    private void miNewCourseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miNewCourseActionPerformed
        String newId = JOptionPane.showInputDialog("New course id: ");

        try {
            Course c = tree.newCourse(newId);
            io.saveCourse(c);
            // reloading tree...
            top = new DefaultMutableTreeNode(tree.getNameInTree());
            createNodes(top);
            DefaultTreeModel model = (DefaultTreeModel) jTree.getModel();
            model.setRoot(top);

        } catch (IOException ex) {
            JOptionPane.showMessageDialog(this,
                    "Can't create main-info.xml file for course");
        } catch (NullPointerException ex) {
            ex.printStackTrace();
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(this, "Cannot save the course " + ex,
                    "Cannot save the course " + ex, JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_miNewCourseActionPerformed

    private void jButtonAddActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAddActionPerformed
        String newId;
        switch (selected) {
        // course selected
        case 0:
            newId = JOptionPane.showInputDialog("New course id: ");

            try {
                Course c = tree.newCourse(newId);
                io.saveCourse(c);
                // reloading tree...
                top = new DefaultMutableTreeNode(tree.getNameInTree());
                createNodes(top);
                DefaultTreeModel model = (DefaultTreeModel) jTree.getModel();
                model.setRoot(top);

            } catch (IOException ex) {
                JOptionPane.showMessageDialog(this,
                        "Can't create main-info.xml file for course");
            } catch (NullPointerException ex) {
                ex.printStackTrace();
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(this, "Cannot save the course "
                        + ex, "Cannot save the course " + ex,
                        JOptionPane.ERROR_MESSAGE);
            }
            break;
        // lecture selected
        case 1:
        case 11:
            newId = JOptionPane.showInputDialog("New lecture id: ");
            try {
                Lecture lect = course.getLectures().newLecture(newId);
                io.saveLecture(lect);
                // adding node
                DefaultTreeModel model = (DefaultTreeModel) jTree.getModel();
                TreePath path = jTree.getNextMatch("Lectures", 0,
                        Position.Bias.Forward);
                MutableTreeNode node = (MutableTreeNode) path
                        .getLastPathComponent();
                // removing all nodes (sorting problem)
                while (node.getChildCount() > 0) {
                    model.removeNodeFromParent((MutableTreeNode) node
                            .getChildAt(0));
                }
                // adding all nodes
                for (Lecture l : course.getLectures().getLectures()) {
                    MutableTreeNode newNode = new DefaultMutableTreeNode(l
                            .getNameInTree());
                    model.insertNodeInto(newNode, node, node.getChildCount());
                }
                // TODO selecting new lecture

            } catch (IOException ex) {
                JOptionPane.showMessageDialog(this,
                        "Can't create XML file for new lecture.");
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(this, "Cannot save the lecture "
                        + ex, "Cannot save the lecture " + ex,
                        JOptionPane.ERROR_MESSAGE);
            }
            break;
        // task selected
        case 2:
        case 22:
            newId = JOptionPane.showInputDialog("New task id: ");
            try {
                Task tas = course.getTasks().newTask(newId);
                io.saveTask(tas);
                // adding node
                DefaultTreeModel model = (DefaultTreeModel) jTree.getModel();
                TreePath path = jTree.getNextMatch("Tasks", 0,
                        Position.Bias.Forward);
                MutableTreeNode node = (MutableTreeNode) path
                        .getLastPathComponent();
                // removing all nodes (sorting problem)
                while (node.getChildCount() > 0) {
                    model.removeNodeFromParent((MutableTreeNode) node
                            .getChildAt(0));
                }
                // adding all nodes
                for (Task t : course.getTasks().getTasks()) {
                    MutableTreeNode newNode = new DefaultMutableTreeNode(t
                            .getNameInTree());
                    model.insertNodeInto(newNode, node, node.getChildCount());
                }
                // TODO selecting new task
            } catch (IOException ex) {
                JOptionPane.showMessageDialog(this,
                        "Can't create XML file for new task.");
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(this, "Cannot save the task "
                        + ex, "Cannot save the task " + ex,
                        JOptionPane.ERROR_MESSAGE);
            }

            break;
        // practice selected
        case 3:
        case 33:
            newId = JOptionPane.showInputDialog("New practice id: ");
            try {
                Practice prac = course.getPractices().newPractice(newId);
                io.savePractice(prac);
                // adding node
                DefaultTreeModel model = (DefaultTreeModel) jTree.getModel();
                TreePath path = jTree.getNextMatch("Practices", 0,
                        Position.Bias.Forward);
                MutableTreeNode node = (MutableTreeNode) path
                        .getLastPathComponent();
                // removing all nodes (sorting problem)
                while (node.getChildCount() > 0) {
                    model.removeNodeFromParent((MutableTreeNode) node
                            .getChildAt(0));
                }
                // adding all nodes
                for (Practice p : course.getPractices().getPractices()) {
                    MutableTreeNode newNode = new DefaultMutableTreeNode(p
                            .getNameInTree());
                    model.insertNodeInto(newNode, node, node.getChildCount());
                }
                // TODO selecting new practice
            } catch (IOException ex) {
                JOptionPane.showMessageDialog(this,
                        "Can't create XML file for new practice.");
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(this, "Cannot save the practice "
                        + ex, "Cannot save the practice " + ex,
                        JOptionPane.ERROR_MESSAGE);
            }
            break;
        // project selected
        case 4:
        case 44:
            newId = JOptionPane.showInputDialog("New project id: ");
            try {
                Project proj = course.getProjects().newProject(newId);
                io.saveProject(proj);
                // adding node
                DefaultTreeModel model = (DefaultTreeModel) jTree.getModel();
                TreePath path = jTree.getNextMatch("Projects", 0,
                        Position.Bias.Forward);
                MutableTreeNode node = (MutableTreeNode) path
                        .getLastPathComponent();
                // removing all nodes (sorting problem)
                while (node.getChildCount() > 0) {
                    model.removeNodeFromParent((MutableTreeNode) node
                            .getChildAt(0));
                }
                // adding all nodes
                for (Project p : course.getProjects().getProjects()) {
                    MutableTreeNode newNode = new DefaultMutableTreeNode(p
                            .getNameInTree());
                    model.insertNodeInto(newNode, node, node.getChildCount());
                }
                // TODO selecting new project
            } catch (IOException ex) {
                JOptionPane.showMessageDialog(this,
                        "Can't create XML file for new project.");
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(this, "Cannot save the project "
                        + ex, "Cannot save the project " + ex,
                        JOptionPane.ERROR_MESSAGE);
            }
            break;
        // error
        default:
            System.out.println("Error selecting item for new item...");
            System.out.println("-> jButtonAddActionPerformed");
        }
    }//GEN-LAST:event_jButtonAddActionPerformed

    private void jTextField3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField3ActionPerformed
        jButtonSave.setEnabled(true);
        jButtonDiscard.setEnabled(true);
    }//GEN-LAST:event_jTextField3ActionPerformed

    private void jTextField2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField2ActionPerformed
        jButtonSave.setEnabled(true);
        jButtonDiscard.setEnabled(true);
    }//GEN-LAST:event_jTextField2ActionPerformed

    private void jTextField1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField1ActionPerformed
        jButtonSave.setEnabled(true);
        jButtonDiscard.setEnabled(true);
    }//GEN-LAST:event_jTextField1ActionPerformed

    private void jButtonDiscardActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonDiscardActionPerformed
        switch (selected) {
        // course selected
        case 0:
            jTextField1.setText(course.getId());
            jTextField2.setText(course.getDescription().getTitle());
            jTextField3.setText(course.getDescription().getBody());
            jButtonDiscard.setEnabled(false);
            break;
        // lecture selected
        case 1:
            jTextField1.setText(lecture.getId());
            jTextField2.setText(lecture.getDescription().getTitle());
            jTextField3.setText(lecture.getDescription().getBody());
            jButtonDiscard.setEnabled(false);
            break;
        // task selected
        case 2:
            jTextField1.setText(task.getId());
            jTextField2.setText(task.getDescription().getTitle());
            jTextField3.setText(task.getDescription().getBody());
            jButtonDiscard.setEnabled(false);
            break;
        // practice selected
        case 3:
            jTextField1.setText(practice.getId());
            jTextField2.setText(practice.getDescription().getTitle());
            jTextField3.setText(practice.getDescription().getBody());
            jButtonDiscard.setEnabled(false);
            break;
        // project selected
        case 4:
            jTextField1.setText(project.getId());
            jTextField2.setText(project.getDescription().getTitle());
            jTextField3.setText(project.getDescription().getBody());
            jButtonDiscard.setEnabled(false);
            break;
        // lectures
        case 11:
            jTextField2.setText(lectures.getDescription().getTitle());
            jTextField3.setText(lectures.getDescription().getBody());
            jButtonDiscard.setEnabled(false);
            break;
        // tasks
        case 22:
            jTextField2.setText(tasks.getDescription().getTitle());
            jTextField3.setText(tasks.getDescription().getBody());
            jButtonDiscard.setEnabled(false);
            break;
        // practices
        case 33:
            jTextField2.setText(practices.getDescription().getTitle());
            jTextField3.setText(practices.getDescription().getBody());
            jButtonDiscard.setEnabled(false);
            break;
        // projects
        case 44:
            jTextField2.setText(projects.getDescription().getTitle());
            jTextField3.setText(projects.getDescription().getBody());
            jButtonDiscard.setEnabled(false);
            break;
        // error
        default:
            System.out.println("Error selecting item to discard changes...");
            System.out.println("-> jButtonDiscardActionPerformed");
        }
    }//GEN-LAST:event_jButtonDiscardActionPerformed

    private void jButtonSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSaveActionPerformed
        File oldFile;
        // for tree update
        TreePath path = jTree.getSelectionPath();
        DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode) path
                .getLastPathComponent();
        // detecting what was selected
        switch (selected) {
        // course selected
        case 0:
            // case: id changed->renaming course directory
            oldFile = course.getDirectory();
            updateCourse(course);
            if (course.getId() != backup.getId()) {
                oldFile.renameTo(course.getDirectory().getAbsoluteFile());
            }
            try {
                if (course != null) {
                    io.saveCourse(course);
                    JOptionPane
                            .showMessageDialog(this, "Course "
                                    + course.getDescription().getTitle()
                                    + " was saved");
                    backup = new ItemBackup(course.getId(), course
                            .getDescription().getTitle(), course
                            .getDescription().getBody());
                    jButtonSave.setEnabled(false);
                    // updating tree node
                    System.out.println(course.getNameInTree());
                    selectedNode.setUserObject(course.getNameInTree());
                    jTree.revalidate();
                    jTree.repaint();
                }
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(this, "Cannot save the course "
                        + course + ex, "Cannot save the course " + course + ex,
                        JOptionPane.ERROR_MESSAGE);
            }
            break;
        // lecture selected
        case 1:
            // case: id changed->new file created, old deleted
            oldFile = lecture.getFile();
            updateLecture(lecture);
            if (lecture.getId() != backup.getId()) {
                oldFile.delete();
            }
            try {
                if (lecture != null) {
                    io.saveLecture(lecture);
                    JOptionPane.showMessageDialog(this, "Lecture "
                            + lecture.getDescription().getTitle()
                            + " was saved");
                    backup = new ItemBackup(lecture.getId(), lecture
                            .getDescription().getTitle(), lecture
                            .getDescription().getBody());
                    jButtonSave.setEnabled(false);
                    // updating tree node
                    System.out.println(lecture.getNameInTree());
                    selectedNode.setUserObject(lecture.getNameInTree());
                    jTree.revalidate();
                    jTree.repaint();
                }
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(this, "Cannot save the lecture "
                        + lecture + ex, "Cannot save the lecture " + lecture
                        + ex, JOptionPane.ERROR_MESSAGE);
            }
            break;
        // task selected
        case 2:
            // case: id changed->new file created, old deleted
            oldFile = task.getFile();
            updateTask(task);
            if (task.getId() != backup.getId()) {
                oldFile.delete();
            }
            try {
                if (task != null) {
                    io.saveTask(task);
                    JOptionPane.showMessageDialog(this, "Task "
                            + task.getDescription().getTitle() + " was saved");
                    backup = new ItemBackup(task.getId(), task.getDescription()
                            .getTitle(), task.getDescription().getBody());
                    jButtonSave.setEnabled(false);
                    // updating tree node
                    System.out.println(task.getNameInTree());
                    selectedNode.setUserObject(task.getNameInTree());
                    jTree.revalidate();
                    jTree.repaint();
                }
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(this, "Cannot save the task "
                        + task + ex, "Cannot save the task " + task + ex,
                        JOptionPane.ERROR_MESSAGE);
            }
            break;
        // practice selected
        case 3:
            // case: id changed->new file created, old deleted
            oldFile = practice.getFile();
            updatePractice(practice);
            if (practice.getId() != backup.getId()) {
                System.out.println("Changing file...");
                oldFile.delete();
            }
            try {
                if (practice != null) {
                    io.savePractice(practice);
                    JOptionPane.showMessageDialog(this, "Practice "
                            + practice.getDescription().getTitle()
                            + " was saved");
                    backup = new ItemBackup(practice.getId(), practice
                            .getDescription().getTitle(), practice
                            .getDescription().getBody());
                    jButtonSave.setEnabled(false);
                    // updating tree node
                    System.out.println(practice.getNameInTree());
                    selectedNode.setUserObject(practice.getNameInTree());
                    jTree.revalidate();
                    jTree.repaint();
                }
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(this, "Cannot save the practice "
                        + practice + ex, "Cannot save the practice " + practice
                        + ex, JOptionPane.ERROR_MESSAGE);
            }
            break;
        // project selected
        case 4:
            // case: id changed->new file created, old deleted
            oldFile = project.getFile();
            updateProject(project);
            if (project.getId() != backup.getId()) {
                oldFile.delete();
            }
            try {
                if (project != null) {
                    io.saveProject(project);
                    JOptionPane.showMessageDialog(this, "Project "
                            + project.getDescription().getTitle()
                            + " was saved");
                    backup = new ItemBackup(project.getId(), project
                            .getDescription().getTitle(), project
                            .getDescription().getBody());
                    jButtonSave.setEnabled(false);
                    // updating tree node
                    System.out.println(project.getNameInTree());
                    selectedNode.setUserObject(project.getNameInTree());
                    jTree.revalidate();
                    jTree.repaint();
                }
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(this, "Cannot save the project "
                        + project + ex, "Cannot save the project " + project
                        + ex, JOptionPane.ERROR_MESSAGE);
            }
            break;
        // lectures
        case 11:
            updateLectures(lectures);
            System.out.println(lectures.getDescription().getBody());
            try {
                if (lectures != null) {
                    io.saveLecturesInfo(lectures);
                    io.saveLecturesInclude(lectures);
                    JOptionPane.showMessageDialog(this, "Lectures info-file "
                            + lectures.getDescription().getTitle()
                            + " was saved");
                    backup = new ItemBackup(lectures.getDescription()
                            .getTitle(), lectures.getDescription().getBody());
                    jButtonSave.setEnabled(false);
                }
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(this, "Cannot save the lectures "
                        + lectures + ex, "Cannot save the lectures " + lectures
                        + ex, JOptionPane.ERROR_MESSAGE);
            }
            break;
        // tasks
        case 22:
            updateTasks(tasks);
            System.out.println(tasks.getDescription().getBody());
            try {
                if (tasks != null) {
                    io.saveTasksInfo(tasks);
                    io.saveTasksInclude(tasks);
                    JOptionPane.showMessageDialog(this, "Tasks info-file "
                            + tasks.getDescription().getTitle() + " was saved");
                    backup = new ItemBackup(tasks.getDescription().getTitle(),
                            tasks.getDescription().getBody());
                    jButtonSave.setEnabled(false);
                }
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(this, "Cannot save the tasks "
                        + tasks + ex, "Cannot save the tasks " + tasks + ex,
                        JOptionPane.ERROR_MESSAGE);
            }
            break;
        // practices
        case 33:
            updatePractices(practices);
            System.out.println(practices.getDescription().getBody());
            try {
                if (practices != null) {
                    io.savePracticesInfo(practices);
                    io.savePracticesInclude(practices);
                    JOptionPane.showMessageDialog(this, "Practices info-file "
                            + practices.getDescription().getTitle()
                            + " was saved");
                    backup = new ItemBackup(practices.getDescription()
                            .getTitle(), practices.getDescription().getBody());
                    jButtonSave.setEnabled(false);
                }
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(this,
                        "Cannot save the practices " + practices + ex,
                        "Cannot save the practices " + practices + ex,
                        JOptionPane.ERROR_MESSAGE);
            }
            break;
        // projects
        case 44:
            updateProjects(projects);
            System.out.println(projects.getDescription().getBody());
            try {
                if (projects != null) {
                    io.saveProjectsInfo(projects);
                    io.saveProjectsInclude(projects);
                    JOptionPane.showMessageDialog(this, "Projects info-file "
                            + projects.getDescription().getTitle()
                            + " was saved");
                    backup = new ItemBackup(projects.getDescription()
                            .getTitle(), projects.getDescription().getBody());
                    jButtonSave.setEnabled(false);
                }
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(this, "Cannot save the projects "
                        + projects + ex, "Cannot save the projects " + projects
                        + ex, JOptionPane.ERROR_MESSAGE);
            }
            break;
        // error
        default:
            System.out.println("Error selecting item to save...");
            System.out.println("-> jButtonSaveActionPerformed");
        }
    }//GEN-LAST:event_jButtonSaveActionPerformed

    private void jButtonDeleteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonDeleteActionPerformed
        // for tree update

        switch (selected) {
        // course selected
        case 0:
            updateCourse(course);
            try {
                if (course != null) {
                    if (JOptionPane.YES_OPTION == JOptionPane
                            .showConfirmDialog(this, "Really delete course "
                                    + course.getDescription().getTitle() + "?",
                                    "Course lecture?",
                                    JOptionPane.YES_NO_OPTION)) {
                        // removing file
                        tree.removeCourse(course);
                        // reloading tree...
                        top = new DefaultMutableTreeNode(tree.getNameInTree());
                        createNodes(top);
                        DefaultTreeModel model = (DefaultTreeModel) jTree
                                .getModel();
                        model.setRoot(top);
                    }
                }
            } catch (NullPointerException ex) {
                ex.printStackTrace();
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(this,
                        "Cannot delete the lecture " + ex,
                        "Cannot delete the lecture " + ex,
                        JOptionPane.ERROR_MESSAGE);
            }
            break;
        // lecture selected
        case 1:
            updateLecture(lecture);
            try {
                if (lecture != null) {
                    if (JOptionPane.YES_OPTION == JOptionPane
                            .showConfirmDialog(this,
                                    "Really delete lecture "
                                            + lecture.getDescription()
                                                    .getTitle() + "?",
                                    "Delete lecture?",
                                    JOptionPane.YES_NO_OPTION)) {
                        // removing file
                        course.getLectures().removeLecture(lecture);
                        io.saveLecturesInclude(course.getLectures());
                        // removing node
                        DefaultTreeModel model = (DefaultTreeModel) jTree
                                .getModel();
                        String prefix = lecture.getNameInTree();
                        TreePath path = jTree.getNextMatch(prefix, 0,
                                Position.Bias.Forward);
                        MutableTreeNode node = (MutableTreeNode) path
                                .getLastPathComponent();
                        jTree.setSelectionPath(path.getParentPath());
                        model.removeNodeFromParent(node);
                    }
                }
            } catch (NullPointerException ex) {
                ex.printStackTrace();
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(this,
                        "Cannot delete the lecture " + ex,
                        "Cannot delete the lecture " + ex,
                        JOptionPane.ERROR_MESSAGE);
            }
            break;
        // task selected
        case 2:
            updateTask(task);
            try {
                if (task != null) {
                    if (JOptionPane.YES_OPTION == JOptionPane
                            .showConfirmDialog(this, "Really delete task "
                                    + task.getDescription().getTitle() + "?",
                                    "Delete task?", JOptionPane.YES_NO_OPTION)) {
                        course.getTasks().removeTask(task);
                        io.saveTasksInclude(course.getTasks());
                        // removing node
                        DefaultTreeModel model = (DefaultTreeModel) jTree
                                .getModel();
                        String prefix = task.getNameInTree();
                        TreePath path = jTree.getNextMatch(prefix, 0,
                                Position.Bias.Forward);
                        MutableTreeNode node = (MutableTreeNode) path
                                .getLastPathComponent();
                        jTree.setSelectionPath(path.getParentPath());
                        model.removeNodeFromParent(node);
                    }
                }
            } catch (NullPointerException ex) {
                ex.printStackTrace();
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(this, "Cannot delete the task "
                        + ex, "Cannot delete the task " + ex,
                        JOptionPane.ERROR_MESSAGE);
            }
            break;
        // practice selected
        case 3:
            updatePractice(practice);
            try {
                if (practice != null) {
                    if (JOptionPane.YES_OPTION == JOptionPane
                            .showConfirmDialog(this, "Really delete practice "
                                    + practice.getDescription().getTitle()
                                    + "?", "Delete practice?",
                                    JOptionPane.YES_NO_OPTION)) {
                        course.getPractices().removePractice(practice);
                        io.savePracticesInclude(course.getPractices());
                        // removing node
                        DefaultTreeModel model = (DefaultTreeModel) jTree
                                .getModel();
                        String prefix = practice.getNameInTree();
                        TreePath path = jTree.getNextMatch(prefix, 0,
                                Position.Bias.Forward);
                        MutableTreeNode node = (MutableTreeNode) path
                                .getLastPathComponent();
                        jTree.setSelectionPath(path.getParentPath());
                        model.removeNodeFromParent(node);
                    }
                }
            } catch (NullPointerException ex) {
                ex.printStackTrace();
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(this,
                        "Cannot delete the practice " + ex,
                        "Cannot delete the practice " + ex,
                        JOptionPane.ERROR_MESSAGE);
            }
            break;
        // project selected
        case 4:
            updateProject(project);
            try {
                if (project != null) {
                    if (JOptionPane.YES_OPTION == JOptionPane
                            .showConfirmDialog(this,
                                    "Really delete project "
                                            + project.getDescription()
                                                    .getTitle() + "?",
                                    "Delete project?",
                                    JOptionPane.YES_NO_OPTION)) {
                        course.getProjects().removeProject(project);
                        io.saveProjectsInclude(course.getProjects());
                        // removing node
                        DefaultTreeModel model = (DefaultTreeModel) jTree
                                .getModel();
                        String prefix = project.getNameInTree();
                        TreePath path = jTree.getNextMatch(prefix, 0,
                                Position.Bias.Forward);
                        MutableTreeNode node = (MutableTreeNode) path
                                .getLastPathComponent();
                        jTree.setSelectionPath(path.getParentPath());
                        model.removeNodeFromParent(node);
                    }
                }
            } catch (NullPointerException ex) {
                ex.printStackTrace();
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(this,
                        "Cannot delete the project " + ex,
                        "Cannot delete the project " + ex,
                        JOptionPane.ERROR_MESSAGE);
            }
            break;
        }
    }//GEN-LAST:event_jButtonDeleteActionPerformed

    private void formWindowGainedFocus(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowGainedFocus
        this.setTitle(APP_TITLE + " - " + tree.getDirectory());
        this.repaint();
    }//GEN-LAST:event_formWindowGainedFocus

    private void jTreeValueChanged(javax.swing.event.TreeSelectionEvent evt) {//GEN-FIRST:event_jTreeValueChanged
        if ((jTree.getSelectionPath() != null) && (!jTree.isSelectionEmpty())) {
            TreePath path = jTree.getSelectionPath().getParentPath();
            DefaultMutableTreeNode parent = (DefaultMutableTreeNode) path
                    .getLastPathComponent();
            String sParent = (String) parent.getUserObject();

            // detecting course selection
            if (sParent == tree.getNameInTree()) {
                // settting the text fields
                path = jTree.getSelectionPath();
                DefaultMutableTreeNode child = (DefaultMutableTreeNode) path
                        .getLastPathComponent();
                String sChild = (String) child.getUserObject();

                for (Course c : tree.getCourses()) {
                    if (sChild.compareTo(c.getNameInTree()) == 0) {
                        course = c;
                        selected = 0;
                        lblSelect.setVisible(false);
                        jLabel1.setText("Course id:");
                        jLabel1.setVisible(true);
                        jTextField1.setText(c.getId());
                        jTextField1.setVisible(true);
                        jLabel2.setText("Course title:");
                        jLabel2.setVisible(true);
                        jTextField2.setText(c.getDescription().getTitle());
                        jTextField2.setVisible(true);
                        jLabel3.setText("Course body: ");
                        jLabel3.setVisible(true);
                        jTextField3.setText(c.getDescription().getBody());
                        jTextField3.setVisible(true);
                        jButtonSave.setVisible(true);
                        jButtonDiscard.setVisible(true);
                        backup = new ItemBackup(c.getId(), c.getDescription()
                                .getTitle(), c.getDescription().getBody());
                        jButtonDelete.setVisible(true);
                        jButtonDelete.setText("Delete this course");
                        jButtonAdd.setVisible(true);
                        jButtonAdd.setText("Add new course");
                        jButtonCopy.setVisible(false);
                        jButtonCopyToNew.setVisible(true);
                        jButtonCopyToNew.setText("Clone this course");
                    }
                }
                // detecting lecture selection
            } else if (sParent == "Lectures") {
                // choosing the right course
                path = jTree.getSelectionPath().getParentPath().getParentPath();
                DefaultMutableTreeNode child = (DefaultMutableTreeNode) path
                        .getLastPathComponent();
                String sChild = (String) child.getUserObject();
                for (Course c : tree.getCourses()) {
                    if (sChild.compareTo(c.getNameInTree()) == 0) {
                        course = c;
                    }
                }
                // setting the text fields
                path = jTree.getSelectionPath();
                child = (DefaultMutableTreeNode) path.getLastPathComponent();
                sChild = (String) child.getUserObject();
                for (Lecture l : course.getLectures().getLectures()) {
                    if (sChild.compareTo(l.getNameInTree()) == 0) {
                        lecture = l;
                        selected = 1;
                        lblSelect.setVisible(false);
                        jLabel1.setText("Lecture id:");
                        jLabel1.setVisible(true);
                        jTextField1.setText(l.getId());
                        jTextField1.setVisible(true);
                        jLabel2.setText("Lecture title:");
                        jLabel2.setVisible(true);
                        jTextField2.setText(l.getDescription().getTitle());
                        jTextField2.setVisible(true);
                        jLabel3.setText("Lecture body: ");
                        jLabel3.setVisible(true);
                        jTextField3.setText(l.getDescription().getBody());
                        jTextField3.setVisible(true);
                        jButtonSave.setVisible(true);
                        jButtonDiscard.setVisible(true);
                        backup = new ItemBackup(l.getId(), l.getDescription()
                                .getTitle(), l.getDescription().getBody());
                        jButtonDelete.setVisible(true);
                        jButtonDelete.setText("Delete this lecture");
                        jButtonAdd.setVisible(true);
                        jButtonAdd.setText("Add new lecture");
                        jButtonCopy.setVisible(true);
                        jButtonCopy.setText("Copy this lecture to...");
                        jButtonCopyToNew.setVisible(true);
                        jButtonCopyToNew
                                .setText("Copy this lecture to new course");
                    }
                }
                // detecting task selection
            } else if (sParent == "Tasks") {
                // choosing the right course
                path = jTree.getSelectionPath().getParentPath().getParentPath();
                DefaultMutableTreeNode child = (DefaultMutableTreeNode) path
                        .getLastPathComponent();
                String sChild = (String) child.getUserObject();
                for (Course c : tree.getCourses()) {
                    if (sChild.compareTo(c.getNameInTree()) == 0) {
                        course = c;
                    }
                }
                // setting the text fields
                path = jTree.getSelectionPath();
                child = (DefaultMutableTreeNode) path.getLastPathComponent();
                sChild = (String) child.getUserObject();
                for (Task t : course.getTasks().getTasks()) {
                    if (sChild.compareTo(t.getNameInTree()) == 0) {
                        task = t;
                        selected = 2;
                        lblSelect.setVisible(false);
                        jLabel1.setText("Task id:");
                        jLabel1.setVisible(true);
                        jTextField1.setText(t.getId());
                        jTextField1.setVisible(true);
                        jLabel2.setText("Task title:");
                        jLabel2.setVisible(true);
                        jTextField2.setText(t.getDescription().getTitle());
                        jTextField2.setVisible(true);
                        jLabel3.setText("Task body: ");
                        jLabel3.setVisible(true);
                        jTextField3.setText(t.getDescription().getBody());
                        jTextField3.setVisible(true);
                        jButtonSave.setVisible(true);
                        jButtonDiscard.setVisible(true);
                        backup = new ItemBackup(t.getId(), t.getDescription()
                                .getTitle(), t.getDescription().getBody());
                        jButtonDelete.setVisible(true);
                        jButtonDelete.setText("Delete this task");
                        jButtonAdd.setVisible(true);
                        jButtonAdd.setText("Add new task");
                        jButtonCopy.setVisible(true);
                        jButtonCopy.setText("Copy this task to...");
                        jButtonCopyToNew.setVisible(true);
                        jButtonCopyToNew
                                .setText("Copy this task to new course");
                    }
                }

                // detecting practice selection
            } else if (sParent == "Practices") {
                // choosing the right course
                path = jTree.getSelectionPath().getParentPath().getParentPath();
                DefaultMutableTreeNode child = (DefaultMutableTreeNode) path
                        .getLastPathComponent();
                String sChild = (String) child.getUserObject();
                for (Course c : tree.getCourses()) {
                    if (sChild.compareTo(c.getNameInTree()) == 0) {
                        course = c;
                    }
                }
                // setting the text fields
                path = jTree.getSelectionPath();
                child = (DefaultMutableTreeNode) path.getLastPathComponent();
                sChild = (String) child.getUserObject();
                for (Practice p : course.getPractices().getPractices()) {
                    if (sChild.compareTo(p.getNameInTree()) == 0) {
                        practice = p;
                        selected = 3;
                        lblSelect.setVisible(false);
                        jLabel1.setText("Practice id:");
                        jLabel1.setVisible(true);
                        jTextField1.setText(p.getId());
                        jTextField1.setVisible(true);
                        jLabel2.setText("Practice title:");
                        jLabel2.setVisible(true);
                        jTextField2.setText(p.getDescription().getTitle());
                        jTextField2.setVisible(true);
                        jLabel3.setText("Practice body: ");
                        jLabel3.setVisible(true);
                        jTextField3.setText(p.getDescription().getBody());
                        jTextField3.setVisible(true);
                        jButtonSave.setVisible(true);
                        jButtonDiscard.setVisible(true);
                        backup = new ItemBackup(p.getId(), p.getDescription()
                                .getTitle(), p.getDescription().getBody());
                        jButtonDelete.setVisible(true);
                        jButtonDelete.setText("Delete this practice");
                        jButtonAdd.setVisible(true);
                        jButtonAdd.setText("Add new practice");
                        jButtonCopy.setVisible(true);
                        jButtonCopy.setText("Copy this practice to...");
                        jButtonCopyToNew.setVisible(true);
                        jButtonCopyToNew
                                .setText("Copy this practice to new course");
                    }
                }
            } else if (sParent == "Projects") {
                // choosing the right course
                path = jTree.getSelectionPath().getParentPath().getParentPath();
                DefaultMutableTreeNode child = (DefaultMutableTreeNode) path
                        .getLastPathComponent();
                String sChild = (String) child.getUserObject();
                for (Course c : tree.getCourses()) {
                    if (sChild.compareTo(c.getNameInTree()) == 0) {
                        course = c;
                    }
                }
                // setting the text fields
                path = jTree.getSelectionPath();
                child = (DefaultMutableTreeNode) path.getLastPathComponent();
                sChild = (String) child.getUserObject();
                for (Project p : course.getProjects().getProjects()) {
                    if (sChild.compareTo(p.getNameInTree()) == 0) {
                        project = p;
                        selected = 4;
                        lblSelect.setVisible(false);
                        jLabel1.setText("Project id:");
                        jLabel1.setVisible(true);
                        jTextField1.setText(p.getId());
                        jTextField1.setVisible(true);
                        jLabel2.setText("Project title:");
                        jLabel2.setVisible(true);
                        jTextField2.setText(p.getDescription().getTitle());
                        jTextField2.setVisible(true);
                        jLabel3.setText("Project body: ");
                        jLabel3.setVisible(true);
                        jTextField3.setText(p.getDescription().getBody());
                        jTextField3.setVisible(true);
                        jButtonSave.setVisible(true);
                        jButtonDiscard.setVisible(true);
                        backup = new ItemBackup(p.getId(), p.getDescription()
                                .getTitle(), p.getDescription().getBody());
                        jButtonDelete.setVisible(true);
                        jButtonDelete.setText("Delete this project");
                        jButtonAdd.setVisible(true);
                        jButtonAdd.setText("Add new project");
                        jButtonCopy.setVisible(true);
                        jButtonCopy.setText("Copy this project to...");
                        jButtonCopyToNew.setVisible(true);
                        jButtonCopyToNew
                                .setText("Copy this project to new course");
                    }
                }
            }
        }

        // lectures, tasks, etc. generally

        if ((jTree.getSelectionPath() != null) && (!jTree.isSelectionEmpty())) {
            // choosing the right course
            TreePath path = jTree.getSelectionPath().getParentPath();
            DefaultMutableTreeNode child = (DefaultMutableTreeNode) path
                    .getLastPathComponent();
            String sChild = (String) child.getUserObject();
            for (Course c : tree.getCourses()) {
                if (sChild.compareTo(c.getNameInTree()) == 0) {
                    course = c;
                }
            }

            path = jTree.getSelectionPath();
            DefaultMutableTreeNode parent = (DefaultMutableTreeNode) path
                    .getLastPathComponent();
            String sParent = (String) parent.getUserObject();

            if (sParent == "Lectures") {
                Lectures ls = course.getLectures();
                lectures = ls;
                selected = 11;
                lblSelect.setVisible(false);
                jLabel1.setText("Lectures for course " + course.getId() + ":");
                jLabel1.setVisible(true);
                // jTextField1.setText(ls.getId());
                jTextField1.setVisible(false);
                jLabel2.setText("Lectures (info) title:");
                jLabel2.setVisible(true);
                jTextField2.setText(ls.getDescription().getTitle());
                jTextField2.setVisible(true);
                jLabel3.setText("Lectures (info) body: ");
                jLabel3.setVisible(true);
                jTextField3.setText(ls.getDescription().getBody());
                jTextField3.setVisible(true);
                jButtonSave.setVisible(true);
                jButtonDiscard.setVisible(true);
                backup = new ItemBackup(ls.getDescription().getTitle(), ls
                        .getDescription().getBody());
                jButtonDelete.setVisible(false);
                jButtonAdd.setVisible(true);
                jButtonAdd.setText("Add new lecture");
                jButtonCopy.setVisible(true);
                jButtonCopy.setText("Copy all lectures to...");
                jButtonCopyToNew.setVisible(true);
                jButtonCopyToNew.setText("Copy all lectures to new course");
            } else if (sParent == "Tasks") {
                Tasks ts = course.getTasks();
                tasks = ts;
                selected = 22;
                lblSelect.setVisible(false);
                jLabel1.setText("Tasks for course " + course.getId() + ":");
                jLabel1.setVisible(true);
                // jTextField1.setText(ls.getId());
                jTextField1.setVisible(false);
                jLabel2.setText("Tasks (info) title:");
                jLabel2.setVisible(true);
                jTextField2.setText(ts.getDescription().getTitle());
                jTextField2.setVisible(true);
                jLabel3.setText("Tasks (info) body: ");
                jLabel3.setVisible(true);
                jTextField3.setText(ts.getDescription().getBody());
                jTextField3.setVisible(true);
                jButtonSave.setVisible(true);
                jButtonDiscard.setVisible(true);
                backup = new ItemBackup(ts.getDescription().getTitle(), ts
                        .getDescription().getBody());
                jButtonDelete.setVisible(false);
                jButtonAdd.setVisible(true);
                jButtonAdd.setText("Add new task");
                jButtonCopy.setVisible(true);
                jButtonCopy.setText("Copy all tasks to...");
                jButtonCopyToNew.setVisible(true);
                jButtonCopyToNew.setText("Copy all tasks to new course");
            } else if (sParent == "Practices") {
                Practices ps = course.getPractices();
                practices = ps;
                selected = 33;
                lblSelect.setVisible(false);
                jLabel1.setText("Practices for course " + course.getId() + ":");
                jLabel1.setVisible(true);
                // jTextField1.setText(ls.getId());
                jTextField1.setVisible(false);
                jLabel2.setText("Practices (info) title:");
                jLabel2.setVisible(true);
                jTextField2.setText(ps.getDescription().getTitle());
                jTextField2.setVisible(true);
                jLabel3.setText("Practices (info) body: ");
                jLabel3.setVisible(true);
                jTextField3.setText(ps.getDescription().getBody());
                jTextField3.setVisible(true);
                jButtonSave.setVisible(true);
                jButtonDiscard.setVisible(true);
                backup = new ItemBackup(ps.getDescription().getTitle(), ps
                        .getDescription().getBody());
                jButtonDelete.setVisible(false);
                jButtonAdd.setVisible(true);
                jButtonAdd.setText("Add new practice");
                jButtonCopy.setVisible(true);
                jButtonCopy.setText("Copy all practices to...");
                jButtonCopyToNew.setVisible(true);
                jButtonCopyToNew.setText("Copy all practices to new course");
            } else if (sParent == "Projects") {
                Projects ps = course.getProjects();
                projects = ps;
                selected = 44;
                lblSelect.setVisible(false);
                jLabel1.setText("Projects for course " + course.getId() + ":");
                jLabel1.setVisible(true);
                // jTextField1.setText(ls.getId());
                jTextField1.setVisible(false);
                jLabel2.setText("Projects (info) title:");
                jLabel2.setVisible(true);
                jTextField2.setText(ps.getDescription().getTitle());
                jTextField2.setVisible(true);
                jLabel3.setText("Projects (info) body: ");
                jLabel3.setVisible(true);
                jTextField3.setText(ps.getDescription().getBody());
                jTextField3.setVisible(true);
                jButtonSave.setVisible(true);
                jButtonDiscard.setVisible(true);
                backup = new ItemBackup(ps.getDescription().getTitle(), ps
                        .getDescription().getBody());
                jButtonDelete.setVisible(false);
                jButtonAdd.setVisible(true);
                jButtonAdd.setText("Add new project");
                jButtonCopy.setVisible(true);
                jButtonCopy.setText("Copy all projects to...");
                jButtonCopyToNew.setVisible(true);
                jButtonCopyToNew.setText("Copy all projects to new course");
            }
        }
    }//GEN-LAST:event_jTreeValueChanged

    // main nodes
    private DefaultMutableTreeNode treeLectures, treeTasks, treePractices,
            treeProjects, treeCourses;

    /**
     * Creates nodes for tree on the left side.
     * @param top root node of the tree - the nodes will be created for this root
     */
    private void createNodes(DefaultMutableTreeNode top) {

        DefaultMutableTreeNode item = null;

        treeCourses = addCoursesNodes(top);
    }

    private DefaultMutableTreeNode addCoursesNodes(DefaultMutableTreeNode top) {
        for (Course c : tree.getCourses()) {
            DefaultMutableTreeNode treeC = new DefaultMutableTreeNode(c.getId()
                    + " (" + c.getDescription().getTitle() + ")");
            top.add(treeC);
            addLecturesNodes(treeC, c);
            addTasksNodes(treeC, c);
            addPracticesNodes(treeC, c);
            addProjectsNodes(treeC, c);
        }
        return top;
    }

    private List<DefaultMutableTreeNode> lecturesInTree;

    private DefaultMutableTreeNode addLecturesNodes(
            DefaultMutableTreeNode treeC, Course c) {
        if (c != null) {
            lecturesInTree = new ArrayList<DefaultMutableTreeNode>();
            treeLectures = new DefaultMutableTreeNode("Lectures");
            treeC.add(treeLectures);

            for (Lecture l : c.getLectures().getLectures()) {
                DefaultMutableTreeNode treeL = new DefaultMutableTreeNode(l
                        .getNameInTree());
                treeLectures.add(treeL);
                lecturesInTree.add(treeL);
            }
        }
        return treeLectures;
    }

    private DefaultMutableTreeNode addTasksNodes(DefaultMutableTreeNode treeC,
            Course c) {
        if (c != null) {
            treeTasks = new DefaultMutableTreeNode("Tasks");
            treeC.add(treeTasks);

            for (Task t : c.getTasks().getTasks()) {
                DefaultMutableTreeNode treeT = new DefaultMutableTreeNode(t
                        .getNameInTree());
                treeTasks.add(treeT);
            }
        }
        return treeTasks;
    }

    private DefaultMutableTreeNode addPracticesNodes(
            DefaultMutableTreeNode treeC, Course c) {
        if (c != null) {
            treePractices = new DefaultMutableTreeNode("Practices");
            treeC.add(treePractices);

            for (Practice p : c.getPractices().getPractices()) {
                DefaultMutableTreeNode treeP = new DefaultMutableTreeNode(p
                        .getNameInTree());
                treePractices.add(treeP);
            }
        }
        return treePractices;
    }

    private DefaultMutableTreeNode addProjectsNodes(
            DefaultMutableTreeNode treeC, Course c) {
        if (c != null) {
            treeProjects = new DefaultMutableTreeNode("Projects");
            treeC.add(treeProjects);

            for (Project p : c.getProjects().getProjects()) {
                DefaultMutableTreeNode treeT = new DefaultMutableTreeNode(p
                        .getNameInTree());
                treeProjects.add(treeT);
            }
        }
        return treeProjects;
    }

    private void miSelectCourseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miSelectCourseActionPerformed
        try {
            File dir = selectDir();
            root = dir.getAbsolutePath();
            if (dir != null) {
                String treeId = dir.getAbsolutePath();
                changeTree(treeId);
                System.out.println(tree);
                this.repaint();
            }
        } catch (NullPointerException ex) {
            ex.printStackTrace();
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(this,
                    "Cannot select the tree: " + ex, "Cannot select the tree",
                    JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_miSelectCourseActionPerformed

    private void miExitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miExitActionPerformed
        try {
            // TODO io.saveCourseTree(tree);
            if (JOptionPane.showConfirmDialog(this,
                    "Do you really want to exit?", "Really exit?",
                    JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE) == 0) {
                System.exit(0);
            }
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(this, "Cannot save the tree: " + ex,
                    "Cannot save the tree", JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_miExitActionPerformed

    /**
     * Dialog for selecting the directory (tree)
     * @return Selected directory (tree) or null (directory not selected)
     */
    protected File selectDir() {
        JFileChooser chooser = new JFileChooser();
        chooser.setDialogTitle("Select the course tree");
        // selecting the current directory as default
        File testDir = new File(root);
        if (testDir.exists()) {
            chooser.setCurrentDirectory(testDir);
        }
        chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        int retval = chooser.showDialog(this, null);
        if (retval == JFileChooser.APPROVE_OPTION) {
            return chooser.getSelectedFile();
        }
        return null;
    }

    /**
     * Changes the tree. Loads the directory, course(s) and lecture(s).
     * If the operations is successful, the message box shows the name of
     * the selected tree.
     * @param id Directory path.
     * @throws MalformedURLException
     * @throws DocumentException
     */
    protected void changeTree(String id) throws MalformedURLException,
            DocumentException {
        tree = io.loadCourseTree(id);
        course = tree.getCurrentCourse();
        lecture = tree.getCurrentLecture();
        this.setTitle(APP_TITLE + " - " + tree.getDirectory());
        this.repaint();
        JOptionPane.showMessageDialog(this, "Selected tree "
                + tree.getDirectory());
    }

    /**
     * Updates the title and body of the course.
     * @param c Course
     */
    protected void updateCourse(Course c) {
        c.setId(jTextField1.getText());
        c.getDescription().setTitle(jTextField2.getText());
        c.getDescription().setBody(jTextField3.getText());
        c.updateNameInTree();
    }

    /**
     * Updates the title and body of the lecture.
     * @param l Lecture
     */
    protected void updateLecture(Lecture l) {
        l.setId(jTextField1.getText());
        l.getDescription().setTitle(jTextField2.getText());
        l.getDescription().setBody(jTextField3.getText());
        l.updateNameInTree();
    }

    /**
     * Updates the title and body of lectures.
     * @param l Lectures
     */
    protected void updateLectures(Lectures l) {
        l.getDescription().setTitle(jTextField2.getText());
        l.getDescription().setBody(jTextField3.getText());
    }

    /**
     * Updates the title and body of the task.
     * @param t Task
     */
    protected void updateTask(Task t) {
        t.setId(jTextField1.getText());
        t.getDescription().setTitle(jTextField2.getText());
        t.getDescription().setBody(jTextField3.getText());
        t.updateNameInTree();
    }

    /**
     * Updates the title and body of tasks.
     * @param t Tasks
     */
    protected void updateTasks(Tasks t) {
        t.getDescription().setTitle(jTextField2.getText());
        t.getDescription().setBody(jTextField3.getText());
    }

    /**
     * Updates the title and body of the practice.
     * @param p Practice
     */
    protected void updatePractice(Practice p) {
        p.setId(jTextField1.getText());
        p.getDescription().setTitle(jTextField2.getText());
        p.getDescription().setBody(jTextField3.getText());
        p.updateNameInTree();
    }

    /**
     * Updates the title and body of practices.
     * @param p Practices
     */
    protected void updatePractices(Practices p) {
        p.getDescription().setTitle(jTextField2.getText());
        p.getDescription().setBody(jTextField3.getText());
    }

    /**
     * Updates the title and body of the project.
     * @param p Project
     */
    protected void updateProject(Project p) {
        p.setId(jTextField1.getText());
        p.getDescription().setTitle(jTextField2.getText());
        p.getDescription().setBody(jTextField3.getText());
        p.updateNameInTree();
    }

    /**
     * Updates the title and body of projects.
     * @param p Projects
     */
    protected void updateProjects(Projects p) {
        p.getDescription().setTitle(jTextField2.getText());
        p.getDescription().setBody(jTextField3.getText());
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new AuthorGUI().setVisible(true);
            }
        });
    }

    // private variables
    public static final String APP_TITLE = "El Author";

    private String root = "C:/tomp/vyuka-test/";

    private CourseTree tree;

    private Course course;

    private Lecture lecture;

    private Lectures lectures;

    private Task task;

    private Tasks tasks;

    private Practice practice;

    private Practices practices;

    private Project project;

    private Projects projects;

    private AuthorIO io;

    private DefaultMutableTreeNode top;

    private ItemBackup backup;

    /*
     * 0 = course
     * 1 = lecture
     * 2 = task
     * 3 = practice
     * 4 = project
     * 11 = lectures
     * 22 = tasks
     * 33 = practices
     * 44 = projects
     */
    private int selected;

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem Contents;

    private javax.swing.JButton jButtonAdd;

    private javax.swing.JButton jButtonAddCopy;

    private javax.swing.JButton jButtonAddNew;

    private javax.swing.JButton jButtonCancel;

    private javax.swing.JButton jButtonCancelCopy;

    private javax.swing.JButton jButtonCopy;

    private javax.swing.JButton jButtonCopyToNew;

    private javax.swing.JButton jButtonDelete;

    private javax.swing.JButton jButtonDiscard;

    private javax.swing.JButton jButtonSave;

    private javax.swing.JComboBox jComboBoxCourse;

    private javax.swing.JComboBox jComboBoxCourseCopy;

    private javax.swing.JFrame jFrameCopy;

    private javax.swing.JFrame jFrameNew;

    private javax.swing.JLabel jLabel1;

    private javax.swing.JLabel jLabel2;

    private javax.swing.JLabel jLabel3;

    private javax.swing.JLabel jLabelCourse;

    private javax.swing.JLabel jLabelCourseCopy;

    private javax.swing.JLabel jLabelNewId;

    private javax.swing.JMenuBar jMenuBar;

    private javax.swing.JMenu jMenuFile;

    private javax.swing.JMenu jMenuHelp;

    private javax.swing.JMenu jMenuLook;

    private javax.swing.JMenu jMenuNew;

    private javax.swing.JPanel jPanel;

    private javax.swing.JPanel jPanel1;

    private javax.swing.JPopupMenu jPopup;

    private javax.swing.JMenuItem jPopupAdd;

    private javax.swing.JMenuItem jPopupCopy;

    private javax.swing.JMenuItem jPopupCopyNew;

    private javax.swing.JMenuItem jPopupDelete;

    private javax.swing.JRadioButtonMenuItem jRMenuLookCross;

    private javax.swing.JRadioButtonMenuItem jRMenuLookDefault;

    private javax.swing.JRadioButtonMenuItem jRMenuLookGTK;

    private javax.swing.JRadioButtonMenuItem jRMenuLookJava;

    private javax.swing.JRadioButtonMenuItem jRMenuLookLinux;

    private javax.swing.JRadioButtonMenuItem jRMenuLookWindows;

    private javax.swing.JScrollPane jScrollPane1;

    private javax.swing.JSeparator jSeparator;

    private javax.swing.JTextField jTextField1;

    private javax.swing.JTextField jTextField2;

    private javax.swing.JTextField jTextField3;

    private javax.swing.JTextField jTextFieldNewId;

    private javax.swing.JTree jTree;

    private javax.swing.JLabel lblSelect;

    private javax.swing.JMenuItem miExit;

    private javax.swing.JMenuItem miBuild;

    private javax.swing.JMenuItem miNewCourse;

    private javax.swing.JMenuItem miNewLecture;

    private javax.swing.JMenuItem miNewPractice;

    private javax.swing.JMenuItem miNewProject;

    private javax.swing.JMenuItem miNewTask;

    private javax.swing.JMenuItem miSaveCourse;

    private javax.swing.JMenuItem miSelectCourse;
    // End of variables declaration//GEN-END:variables

}
