/*
 * Created on 8.5.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package net.sf.tomp.el.is;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Properties;

import net.sf.tomp.el.author.Course;
import net.sf.tomp.el.author.CourseTree;
import net.sf.tomp.el.author.Lecture;

/**
 * @author tomp
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class BuildConfig {

    private String buildProperties;

    private CourseTree courseTree;

    private Course course;

    private Lecture lecture;

    private Term term;

    private String parameters;

    private String principalDoc;
    
    private String verbosity;

    public BuildConfig(CourseTree ct, String bp) throws IOException {
        courseTree = ct;
        buildProperties = bp;
        loadPreferences();
    }

    public BuildConfig(CourseTree ct) throws IOException {
        this(ct, "build.properties");
    }

    public void build() {

    }

    /**
     * @return Returns the buildProperties.
     */
    public String getBuildProperties() {
        return buildProperties;
    }

    /**
     * @param buildProperties The buildProperties to set.
     */
    public void setBuildProperties(String buildProperties) {
        this.buildProperties = buildProperties;
    }

    /**
     * @return Returns the course.
     */
    public Course getCourse() {
        return course;
    }

    /**
     * @param course The course to set.
     */
    public void setCourse(Course course) {
        this.course = course;
    }

    /**
     * @return Returns the lecture.
     */
    public Lecture getLecture() {
        return lecture;
    }

    /**
     * @param lecture The lecture to set.
     */
    public void setLecture(Lecture lecture) {
        this.lecture = lecture;
    }

    /**
     * @return Returns the parameters.
     */
    public String getParameters() {
        return parameters;
    }

    /**
     * @param parameters The parameters to set.
     */
    public void setParameters(String parameters) {
        this.parameters = parameters;
    }

    /**
     * @return Returns the principalDoc.
     */
    public String getPrincipalDoc() {
        return principalDoc;
    }

    /**
     * @param principalDoc The principalDoc to set.
     */
    public void setPrincipalDoc(String principalDoc) {
        this.principalDoc = principalDoc;
    }

    /**
     * @return Returns the term.
     */
    public Term getTerm() {
        return term;
    }

    /**
     * @param term The term to set.
     */
    public void setTerm(Term term) {
        this.term = term;
    }

    /**
     * @return Returns the courseTree.
     */
    public CourseTree getCourseTree() {
        return courseTree;
    }

    protected void savePreferences(OutputStream os) throws IOException {
        Properties p = new Properties();
        if (term != null)
            p.setProperty("el.term", term.getId());
        if (course != null)
            p.setProperty("el.subject", course.getId());
        if (lecture != null)
            p.setProperty("el.lecture", lecture.getId());
        if (parameters != null)
            p.setProperty("el.parameters", parameters);
        if (principalDoc != null)
            p.setProperty("el.principal.doc", principalDoc);
        if (verbosity != null)
            p.setProperty("el.verbosity", verbosity);
        p.store(os, "El Author Build Preferences");
    }

    protected void savePreferences(File f) throws IOException {
        savePreferences(new FileOutputStream(f));
    }

    protected void savePreferences(String s) throws IOException {
        savePreferences(new File(courseTree.getDirectory(), s));
    }

    protected void savePreferences() throws IOException {
        savePreferences(buildProperties);
    }

    protected void loadPreferences(InputStream is) throws IOException {
        Properties p = new Properties();
        p.load(is);
        
        verbosity = p.getProperty("el.verbosity");

        parameters = p.getProperty("el.parameters");
        //		System.out.println("parameters="+parameters);

        principalDoc = p.getProperty("el.principal.doc");
        //		System.out.println("principalDoc="+principalDoc);

        term = new Term(p.getProperty("el.term"));
        //		System.out.println("term="+term);

        course = courseTree.getCourse(p.getProperty("el.subject"));
        //		System.out.println("course="+course);

        if (course != null) {
            lecture = course.getLectures().getLecture(
                    p.getProperty("el.lecture"));
            //		System.out.println("lecture="+lecture);
        }
    }

    protected void loadPreferences(File f) throws IOException {
        loadPreferences(new FileInputStream(f));
    }

    protected void loadPreferences(String s) throws IOException {
        loadPreferences(new File(courseTree.getDirectory(), s));
    }

    protected void loadPreferences() throws IOException {
        loadPreferences(buildProperties);
    }

    /**
     * @return Returns the verbosity.
     */
    public String getVerbosity() {
        return verbosity;
    }
    /**
     * @param verbosity The verbosity to set.
     */
    public void setVerbosity(String verbosity) {
        this.verbosity = verbosity;
    }
}
