/*
 * Created on 1.5.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package net.sf.tomp.el.is;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FilenameFilter;
import java.io.IOException;
import java.io.OutputStream;
import java.util.Collection;
import java.util.prefs.BackingStoreException;
import java.util.prefs.Preferences;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import org.apache.tools.ant.DemuxOutputStream;
import org.apache.tools.ant.Project;

import net.sf.tomp.el.author.Course;
import net.sf.tomp.el.author.CourseTree;
import net.sf.tomp.el.author.Lecture;
import net.sf.tomp.el.author.Lectures;
import net.sf.tomp.el.author.io.AuthorIO;

/**
 * @author tomp
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class Main extends JFrame {

	/**
	 * Comment for <code>serialVersionUID</code>
	 */
	private static final long serialVersionUID = 2518717598236666583L;

	public static final String VERSION = "0.9";

	protected JTextField textTerm, textBuildProperties;

	protected JCheckBox verbose;

	protected JComboBox comboCourse, comboLecture, comboBuildProperties,
			comboPrincipalDoc, comboParameters;

	protected JTextArea textArea;

	protected JPanel whatBuildPanel;

	protected JButton processButton;

	protected BuildConfig config, defaultConfig;

	protected boolean standalone = true;

	protected Collection<String> principals;

	public static void main(String[] args) throws Exception {
		AuthorIO aio = new AuthorIO();
		CourseTree ct = new CourseTree(new File("c:/tomp/vyuka-test"));
		aio.loadCourses(ct);

		BuildConfig bc = new BuildConfig(ct);
		new Main(bc, true).setVisible(true);
	}

	public Main(BuildConfig cnf, boolean std) throws IOException {

		standalone = std;

		defaultConfig = config = cnf;
		config.loadPreferences();

		try {
			// Nastav titulek okna
			setTitle("El Author Build Configurator v" + VERSION + " ["
					+ config.getCourseTree().getDirectory() + "]");

			// Zsk vnitn panel okna
			JPanel p = new JPanel();

			// Nastav zpsob rozmstn komponent v panelu
			p.setLayout(new BoxLayout(p, BoxLayout.Y_AXIS));

			JPanel chbPanel = new JPanel();
			chbPanel.setBorder(BorderFactory.createCompoundBorder(BorderFactory
					.createTitledBorder("Select Build Properties File"),
					BorderFactory.createEmptyBorder(3, 3, 3, 3)));

			chbPanel.setLayout(new BoxLayout(chbPanel, BoxLayout.X_AXIS));
			// Vytvo polko "verbose"
			verbose = new JCheckBox("Verbose");
			verbose.setEnabled(true);
			verbose.setAlignmentX(Component.RIGHT_ALIGNMENT);
			// Pid rychlou npovdu k polku
			verbose.setToolTipText("Set verbose processing.");

			// Vytvo popisek vstupniho pole
			JLabel labelBuildProperties = new JLabel("Build properties");
			// Vstupn textov pole k zadn tdb
			textBuildProperties = new JTextField(config.getBuildProperties());
			labelBuildProperties.setLabelFor(textBuildProperties);

			// load preferences
			comboBuildProperties = new JComboBox();
			comboBuildProperties.addActionListener(new ActionListener() {

				public void actionPerformed(ActionEvent e) {
					try {
						Object o = comboBuildProperties.getSelectedItem();
						if (o != null) {
							config = new BuildConfig(config.getCourseTree(), o
									.toString());
							//                            messageDialog("changed BC to
							// "+config.getBuildProperties());
							config.loadPreferences();

							if (comboCourse != null) {
								putCourseNames();
								putLectureNames();
								putPrincipalDocsNames();
								preferencesConfigToGui();
								//                                dumpConfig();
							}
						}
					} catch (Exception ioe) {
						error(
								"comboBuildProperties: Cannot load build preferences",
								ioe);
					}
				}
			});

			putBuildPropertiesFileNames();

			// save preferences
			final JButton savePrefsButton = new JButton("Save");
			savePrefsButton.addActionListener(new ActionListener() {

				public void actionPerformed(ActionEvent e) {
					try {
						preferencesGuiToConfig();
						config.savePreferences();
					} catch (Exception ioe) {
						error("Cannot save build preferences", ioe);
					}
				}
			});

			// load preferences
			final JButton saveAsPrefsButton = new JButton("Save Copy");
			saveAsPrefsButton.addActionListener(new ActionListener() {

				public void actionPerformed(ActionEvent e) {
					File saveTo = null;
					try {
						saveTo = selectSaveFile(config.getCourseTree()
								.getDirectory().getCanonicalPath());
						if (saveTo != null) {
							preferencesGuiToConfig();
							config.savePreferences(saveTo);
							putBuildPropertiesFileNames();
						}
					} catch (Exception ioe) {
						error("Cannot save build preferences to " + saveTo, ioe);
						throw new RuntimeException(ioe);
					}
				}
			});

			chbPanel.add(comboBuildProperties);
			chbPanel.add(savePrefsButton);
			chbPanel.add(saveAsPrefsButton);
			p.add(chbPanel);

			JPanel bpPanel = new JPanel();
			bpPanel.setBorder(BorderFactory.createCompoundBorder(BorderFactory
					.createTitledBorder("Build Properties"), BorderFactory
					.createEmptyBorder(3, 3, 3, 3)));

			bpPanel.setLayout(new BoxLayout(bpPanel, BoxLayout.Y_AXIS));

			JPanel coursePanel = new JPanel();
			coursePanel.setLayout(new BoxLayout(coursePanel, BoxLayout.X_AXIS));

			// Vytvo popisek vstupniho pole
			JLabel labelCourse = new JLabel("Course");

			comboCourse = new JComboBox();
			putCourseNames();
			comboCourse.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					Object o = comboCourse.getSelectedItem();
					if (o != null) {
						Course course = config.getCourseTree().getCourse(
								o.toString());
						if (course != null) {
							config.setCourse(course);

							Object o2 = comboLecture.getSelectedItem();
							if (o2 != null) {
								Lecture lecture = config.getCourse()
										.getLectures()
										.getLecture(o2.toString());
								if (lecture != null) {
									config.setLecture(lecture);
								}
							}
						}
					}
					putLectureNames();
				}
			});

			coursePanel.add(labelCourse);
			coursePanel.add(comboCourse);
			bpPanel.add(coursePanel);

			JPanel lecturePanel = new JPanel();
			lecturePanel
					.setLayout(new BoxLayout(lecturePanel, BoxLayout.X_AXIS));

			// Vytvo popisek vstupniho pole
			JLabel labelLecture = new JLabel("Lecture");

			// Vytvo popisek vstupniho pole
			comboLecture = new JComboBox();
			putLectureNames();

			lecturePanel.add(labelLecture);
			lecturePanel.add(comboLecture);
			bpPanel.add(lecturePanel);

			JPanel termPanel = new JPanel();
			termPanel.setLayout(new BoxLayout(termPanel, BoxLayout.X_AXIS));

			// Vytvo popisek vstupniho pole
			JLabel labelTerm = new JLabel("Term");
			textTerm = new JTextField();
			labelTerm.setLabelFor(textTerm);

			termPanel.add(labelTerm);
			termPanel.add(textTerm);
			bpPanel.add(termPanel);

			JPanel parametersPanel = new JPanel();
			parametersPanel.setLayout(new BoxLayout(parametersPanel,
					BoxLayout.X_AXIS));

			// Vytvo popisek vstupniho pole
			JLabel labelParameters = new JLabel("Parameters");
			comboParameters = new JComboBox();
			labelParameters.setLabelFor(comboParameters);

			parametersPanel.add(labelParameters);
			parametersPanel.add(comboParameters);
			bpPanel.add(parametersPanel);

			JPanel principalDocPanel = new JPanel();
			principalDocPanel.setLayout(new BoxLayout(principalDocPanel,
					BoxLayout.X_AXIS));

			// Vytvo popisek vstupniho pole
			JLabel labelPrincipalDoc = new JLabel("Principal Document");
			comboPrincipalDoc = new JComboBox();
			labelPrincipalDoc.setLabelFor(comboPrincipalDoc);

			principalDocPanel.add(labelPrincipalDoc);
			principalDocPanel.add(comboPrincipalDoc);
			bpPanel.add(principalDocPanel);
			bpPanel.add(verbose);
			p.add(bpPanel);

			JPanel consolePanel = new JPanel();
			consolePanel.setBorder(BorderFactory.createCompoundBorder(
					BorderFactory.createTitledBorder("Build Messages"),
					BorderFactory.createEmptyBorder(3, 3, 3, 3)));
			textArea = new JTextArea(10, 40);
			textArea.setEditable(false);
			JScrollPane scrollPane = new JScrollPane(textArea,
					JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
					JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);

			consolePanel.add(scrollPane);

			whatBuildPanel = new JPanel();
			whatBuildPanel.setLayout(new BoxLayout(whatBuildPanel,
					BoxLayout.Y_AXIS));
			consolePanel.add(whatBuildPanel);
			p.add(consolePanel);

			JPanel buttonPanel = new JPanel();
			buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.X_AXIS));

			// Vytvo tlatko ke smazani konzoly
			JButton clearButton = new JButton("Clear console");
			clearButton.setToolTipText("Clear the console.");
			// Nastav posluchae akce "stisk tlatka"
			clearButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					textArea.setText("");
					textArea.repaint();
				}
			});
			buttonPanel.add(clearButton);

			// Vytvo tlatko ke sputn zpracovani
			JButton exitButton = new JButton("Exit");
			exitButton.setToolTipText("Exit the program.");
			// Nastav posluchae akce "stisk tlatka"
			exitButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (standalone)
						System.exit(0);
					else
						setVisible(false);
				}
			});
			buttonPanel.add(exitButton);
			p.add(buttonPanel);

			// Pi zaven okna ukon aplikaci
			addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					if (standalone)
						System.exit(0);
				}
			});

			// Vytvo tlatko ke sputn zpracovani
			processButton = new JButton("Process");
			processButton.setToolTipText("Process the build.");
			// Nastav posluchae akce "stisk tlatka"
			processButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					process();
				}
			});

			preferencesConfigToGui();
			putPrincipalDocsNames();
			putParameterDirNames();

			getContentPane().add(p);
			pack();
		} catch (Exception e) {
			throw new RuntimeException(e);
			//            error(e.toString());
		}

	}

	public class GUIOutputStream extends OutputStream {

		private StringBuffer content = new StringBuffer();

		private boolean isErr = false;

		/**
		 * @param isErr
		 */
		public GUIOutputStream(boolean isErr) {
			super();
			this.isErr = isErr;
		}

		/*
		 * (non-Javadoc)
		 * 
		 * @see java.io.OutputStream#write(int)
		 */
		public void write(int b) throws IOException {
			//            messageDialog("write to GUIOutputStream "+b);
			content.append((char) b);
		}

		/*
		 * (non-Javadoc)
		 * 
		 * @see java.io.Flushable#flush()
		 */
		public void flush() throws IOException {
			// TODO Auto-generated method stub
			textArea.append(content.toString());
			//            messageDialog("flush GUIOutputStream "+content);
			textArea.repaint();
			content.setLength(0);
			super.flush();
		}

		/*
		 * (non-Javadoc)
		 * 
		 * @see java.io.Flushable#flush()
		 */
		public void close() throws IOException {
			super.close();
		}
	}

	protected void process() {
		try {
			resetConfig();
			AntLauncher al = new AntLauncher(this);
			al.doTargets(new String[]{"main2" });
			//            messageDialog("Processing done OK");
		} catch (IOException e) {
			error(e.toString());
		}

	}

	protected void messageDialog(String message) {
		JOptionPane.showMessageDialog(this, message, message,
				JOptionPane.INFORMATION_MESSAGE);
	}

	protected void errorDialog(String message) {
		JOptionPane.showMessageDialog(this, message, message,
				JOptionPane.ERROR_MESSAGE);
	}

	protected void message(String message) {
		textArea.append(message);
	}

	protected void error(Throwable t) {
		String m = t.getMessage();
		if (m != null) {
			textArea.append(m);
		}
	}

	protected void putBuildPropertiesFileNames() {
		comboBuildProperties.removeAllItems();

		File treeDir = config.getCourseTree().getDirectory();
		File[] potentialBuildProperties = treeDir
				.listFiles(new FilenameFilter() {
					public boolean accept(File f, String fn) {
						return fn.startsWith("build")
								&& fn.endsWith(".properties");
					}
				});

		for (int i = 0; i < potentialBuildProperties.length; i++) {
			comboBuildProperties.addItem(potentialBuildProperties[i].getName());
		}
	}

	protected void putCourseNames() {
		comboCourse.removeAllItems();

		Collection<Course> cs = config.getCourseTree().getCourses();

		for (Course c : cs) {
			comboCourse.addItem(c.getId());
		}
	}

	protected void putLectureNames() {
		comboLecture.removeAllItems();

		Course c = config.getCourse();

		if (c != null) {
			Lectures lects = c.getLectures();

			for (Lecture lect : lects.getLectures()) {
				comboLecture.addItem(lect.getId());
			}
		}
	}

	protected void putPrincipalDocsNames() {
		comboPrincipalDoc.removeAllItems();
		whatBuildPanel.removeAll();
		Course c = config.getCourse();
		if (c != null) {
			String[] principalNames = FileUtils.listPrincipalNames(new File(c
					.getDirectory(), "src"));

			for (String pn : principalNames) {
				comboPrincipalDoc.addItem(pn);
				JCheckBox chkb = new JCheckBox(pn);
				whatBuildPanel.add(chkb);
			}
			whatBuildPanel.add(processButton);
		}
	}

	protected void putParameterDirNames() {
		comboParameters.removeAllItems();
		CourseTree c = config.getCourseTree();
		if (c != null) {
			//            messageDialog("c.getDir="+c.getDirectory());
			messageDialog("c.getSrcDir=" + new File(c.getDirectory(), "system"));
			String[] parameterDirNames = FileUtils
					.listParameterDirNames(new File(c.getDirectory(), "system"));

			for (String pn : parameterDirNames) {
				comboParameters.addItem(pn);
			}
		}
	}

	protected void error(String message, Exception e) {
		JOptionPane.showMessageDialog(this, e.toString(), message,
				JOptionPane.INFORMATION_MESSAGE);
	}

	protected void error(String message) {
		JOptionPane.showMessageDialog(this, message, message,
				JOptionPane.INFORMATION_MESSAGE);
	}

	protected void preferencesConfigToGui() {

		verbose.setSelected(config.getVerbosity() != null);

		comboBuildProperties.setSelectedItem(config.getBuildProperties());
		//        		textArea.append("bp OK\n");

		Course c = config.getCourse();
		if (c != null)
			comboCourse.setSelectedItem(c.getId());
		//        		textArea.append("course OK\n");

		Lecture l = config.getLecture();
		if (l != null)
			comboLecture.setSelectedItem(l.getId());
		//        		textArea.append("lecture OK\n");

		Term t = config.getTerm();
		if (t != null)
			textTerm.setText(t.getId());
		//        		textArea.append("term OK\n");

		String p = config.getParameters();
		if (p != null) {
			comboParameters.setSelectedItem(p.substring(FileUtils.PARAM_PREF.length()));
			//        		textArea.append("params OK\n");
		}
		comboPrincipalDoc.setSelectedItem(config.getPrincipalDoc());
		//		textArea.append("princ doc OK\n");
	}

	protected void dumpConfig() {
		textArea.append(config.getBuildProperties() + "\n");

		Course c = config.getCourse();
		if (c != null)
			textArea.append(c.getId() + "\n");

		Lecture l = config.getLecture();
		if (l != null)
			textArea.append(l.getId() + "\n");

		Term t = config.getTerm();
		if (t != null)
			textArea.append(t.getId() + "\n");

		textArea.append(config.getParameters() + "\n");
		textArea.append(config.getPrincipalDoc() + "\n");
		textArea.append(config.getVerbosity() + "\n");
	}

	protected void preferencesGuiToConfig() {

		config.setBuildProperties(comboBuildProperties.getSelectedItem()
				.toString());

		Course course = config.getCourseTree().getCourse(
				comboCourse.getSelectedItem().toString());
		if (course != null) {
			config.setCourse(course);
			Object si = comboLecture.getSelectedItem();
			if (si != null) {
				Lecture lecture = config.getCourse().getLectures().getLecture(
						si.toString());
				config.setLecture(lecture);
			}
		}

		config.setTerm(new Term(textTerm.getText()));

		Object sp = comboParameters.getSelectedItem();
		if (sp != null) {
			config.setParameters(FileUtils.PARAM_PREF + sp);
		}

		Object si = comboPrincipalDoc.getSelectedItem();
		if (si != null) {
			config.setPrincipalDoc(si.toString());
		}
		config.setVerbosity(verbose.isSelected() ? "verbose" : null);
	}

	/*
	 * protected Preferences storePreferences() throws BackingStoreException {
	 * Preferences p = Preferences.userNodeForPackage(Main.class);
	 * p.putBoolean("verbose", verbose.isSelected()); p.flush(); return p; }
	 * 
	 * protected Preferences restorePreferences() { Preferences p =
	 * Preferences.userNodeForPackage(Main.class);
	 * verbose.setSelected(p.getBoolean("verbose", false)); return p; }
	 */
	/**
	 * @return Returns the comboPrincipalDoc.
	 */
	public JComboBox getComboPrincipalDoc() {
		return comboPrincipalDoc;
	}

	/**
	 * @param comboPrincipalDoc
	 *            The comboPrincipalDoc to set.
	 */
	public void setComboPrincipalDoc(JComboBox comboPrincipalDoc) {
		this.comboPrincipalDoc = comboPrincipalDoc;
	}

	/**
	 * @return Returns the config.
	 */
	public BuildConfig getBuildConfig() {
		return config;
	}

	/**
	 * Dialog for selecting the directory (tree)
	 * 
	 * @return Selected directory (tree) or null (directory not selected)
	 */
	protected File selectSaveFile(String fn) {
		JFileChooser chooser = null;
		if (fn == null) {
			chooser = new JFileChooser();
		} else {
			chooser = new JFileChooser(new File(fn).getParentFile());
		}
		chooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
		int retval = chooser.showSaveDialog(this);
		if (retval == JFileChooser.APPROVE_OPTION) {
			return chooser.getSelectedFile();
		}
		return null;
	}

	protected void resetConfig() {
		config = defaultConfig;
		preferencesConfigToGui();
	}

}
